# ViPErLEED

ViPErLEED is an open-source package for quantitative low-energy electron
diffraction, also known as LEED-*I*(*V*). It comprises tools for measurement,
processing, and analysis of LEED-*I*(*V*) results, calculation of theoretical
*I*(*V*) curves based on a structural model of a surface, and optimization of
such a model to best fit the experimental results.

You can find the full documentation under <https://viperleed.org>.

This repository contains the `viperleed.calc` package, the graphical user
interface (GUI) and the software related to the ViPErLEED electronics.

The ViPErLEED ImageJ plugins are available under
<https://github.com/viperleed/viperleed-imagej>

The TensErLEED back-end code used by `viperleed.calc` is available under
<https://github.com/viperleed/viperleed-tensorleed>

For installation instructions see
<https://viperleed.org/content/installation.html>

For a documentation of the `viperleed` Python API see
<https://viperleed.org/content/api.html>

#### Reporting bugs
You can ask questions, report bugs, and propose new features by creating
a new issue under <https://github.com/viperleed/viperleed/issues>. This
is the preferred means of communication with us.

Alternatively, you can contact us via email at <riva@iap.tuwien.ac.at>.

module tenserleed_intpol
      use, intrinsic :: iso_fortran_env
      integer, parameter :: tdp = REAL64
    contains
!C-------------------------------------------------------------------------------
!C  Subroutine INTPOL interpolates LEED intensities onto a working grid (with
!C  steps of EINCR eV).

      SUBROUTINE INTPOL(A,NE,E,NGP,EINCR,IPR,X,WORYT,IB)

        REAL(tdp) :: A(NGP), E(NGP), EINCR, X(NGP), WORYT(NGP), XMIN, XVAL
        INTEGER NE, IPR, IB, ITIL, ITIH, IMIN, LMIN, LMAX
  
   10   FORMAT(54H0 IN THIS BEAM TOO FEW ENERGY VALUES FOR INTERPOLATION)
   20   FORMAT(40H*INTENSITIES AFTER INTERPOLATION IN BEAM,1I4,&
        
   100(5(1F7.2,1E13.4,3X),/))
  
        ITIL = 0
        ITIH = 0
  
  !C  find first non-zero intensity and skip beam, if only one or less are found
  
        DO IE = 1,NE
          IMIN = IE
          IF (A(IE).GT.1.E-8) GO TO 100
        ENDDO
   100  CONTINUE
  
        IF (IMIN.EQ.NE) THEN                                               !200480
          NE = 0                                                           !200480
          WRITE(6,10)                                                     !230480
          RETURN
        END IF
  
  !C  calculate energy range in units of EINCR
  
        LMIN = INT((E(IMIN)-0.0001) / EINCR) + 1
        LMIN = MAX0(LMIN,0)
        XMIN = FLOAT(LMIN) * EINCR
        LMAX = INT((E(NE)+0.0001) / EINCR)
  
        DO I = IMIN,NE
          X(I-IMIN+1) = E(I)
          WORYT(I-IMIN+1) = A(I)
        ENDDO
        NEM = NE - IMIN + 1
  
  !C  NPTS is no. of working grid points
  
        NPTS = LMAX - LMIN + 1
        NE = NPTS
  
        XVAL = XMIN - EINCR

  
  !C  interpolate intensities (negative intensities are set to zero)
  
        DO I = 1,NPTS
          XVAL = XVAL + EINCR
          A(I) = YVAL(XVAL,WORYT,X,NEM,ITIL,ITIH)
          IF (A(I).LT.0.0) THEN
            A(I)=0.0
          ENDIF
        ENDDO
  
  !C  calculate energy grid
  
        E(1) = XMIN
        DO IE = 2,NPTS
          E(IE) = E(IE-1) + EINCR
        ENDDO
  
  !C  print working grid and interpolated intensities, if desired
  
        IF (IPR.EQ.2.AND.NE.GT.0) THEN
          WRITE(6,20) IB, (E(IE),A(IE),IE=1,NE)
        ENDIF
  
        RETURN
        END
  !C-----------------------------------------------------------------------
  
  
!  C-----------------------------------------------------------------------
!  C  FUNCTION YVAL INTERPOLATES
      real(tdp) FUNCTION YVAL(X, WORY, WORX, LENGTH,ITIL,ITIH)
      real(tdp) :: WORY(LENGTH), WORX(LENGTH)
      real(tdp) :: X, Y
      COMMON /DATBLK/ X0,X1,X2,X3,Y0,Y1,Y2,Y3
!  C  IF FEWER THAN FOUR GRID POINTS AVAILABLE, USE 2ND OR 1ST ORDER
!  C  POLYNOMIAL INTERPOLATION
      IF (LENGTH.LT.4) GO TO 10
!  C  FIND REQUIRED INTERPOLATION INTERVAL
      CALL BINSRX(IL, IH, X, WORX, LENGTH)
!  C  SKIP NEXT STEP IF SAME INTERVAL IS FOUND AS LAST TIME
      IF(IL .EQ. ITIL .AND. IH .EQ. ITIH) GO TO 5
!  C  FIND FOUR NEAREST GRID POINTS AND CORRESPONDING INTENSITIES
!  C  FOR 3RD-ORDER POLYNOMIAL INTERPOLATION
      CALL STFPTS(IL, IH, WORX, WORY, LENGTH)
!  C  DO ACTUAL 3RD-ORDER POLYNOMIAL INTERPOLATION
  5    Y = XNTERP(X)
      ITIH = IH
      ITIL = IL
      YVAL = Y
      GO TO 20
  10    CALL XNTRP2(X,Y,WORX,WORY,LENGTH)
      YVAL=Y
  20    RETURN
      END
  
!  C-----------------------------------------------------------------------
!  C  SUBROUTINE BINSRX FINDS A REQUIRED INTERPOLATION INTERVAL
!  C  BY BINARY SEARCH (SUCCESSIVE HALVING OF INITIAL INTERVAL)
      SUBROUTINE BINSRX(IL, IH, X, WORX, LENGTH)
      real(tdp) :: WORX(LENGTH), X
      I = (LENGTH + 1) / 2
      IHI =  (I + 1) / 2
      IF(X.LT. WORX(1) .OR. X .GE. WORX(LENGTH)) GO TO 100
  20    CONTINUE
      IF(I .LT. 1) GO TO 40
      IF(I .GE. LENGTH) GO TO 30
      IF(X .GE.WORX(I) .AND. X .LE. WORX(I + 1)) GO TO 50
      IF(X .LT. WORX(I)) GO TO 30
  40    I = IHI + I
      IHI = (IHI + 1) / 2
      GO TO 20
  30    I = I - IHI
      IHI =(IHI + 1) / 2
      GO TO 20
  50    IL = I
      IH = I + 1
      GO TO 110
  100   IF(X .LT. WORX(1)) GO TO 105
  102   IL = LENGTH - 1
      IH = LENGTH
      GO TO 110
  105   IL = 1
      IH = 2
  110   RETURN
      END
!  C-----------------------------------------------------------------------
  
!  C------------------------------------------------------------------------
!  C  SUBROUTINE STFPTS FINDS, GIVEN THE INTERPOLATION INTERVAL, THE
!  C  FOUR NEAREST GRID POINTS AND THE CORRESPONDING ORDINATE VALUES
        SUBROUTINE STFPTS(IL, IH, WORX, WORY, LENGTH)
        real(tdp) :: WORX(LENGTH), WORY(LENGTH), TEMP(2, 4)
        COMMON / DATBLK/ X0, X1, X2, X3, Y0, Y1, Y2, Y3
        I = IL - 1
        IF(IL .LE. 1) I = I + 1
        IF(IH .GE. LENGTH) I = I - 1
        DO 10 K = 1, 4
        N = K + I - 1
        TEMP(1,K) = WORX(N)
  10    TEMP(2, K) = WORY(N)
        X0 = TEMP(1, 1)
        X1 = TEMP(1, 2)
        X2 = TEMP(1, 3)
        X3 = TEMP(1, 4)
        Y0 = TEMP(2, 1)
        Y1 = TEMP(2, 2)
        Y2 = TEMP(2, 3)
        Y3 = TEMP(2, 4)
        RETURN
        END

  !C-----------------------------------------------------------------------
!C  SUBROUTINE XNTERP PERFORMS 3RD-ORDER POLYNOMIAL INTERPOLATION
      FUNCTION XNTERP(X)
            real(tdp) :: X
      COMMON / DATBLK / X0, X1, X2, X3, Y0, Y1, Y2, Y3
      TERM = Y0
      FACT1 = X - X0
      FACT2 = (Y1 - Y0) / (X1 - X0)
      TERM = TERM + FACT1 * FACT2
      FACT1 = FACT1 * (X - X1)
      FACT2 = ((Y2 - Y1)/(X2 - X1) - FACT2) / (X2 - X0)
      TERM = TERM + FACT1 * FACT2
      FACT1 = FACT1 * (X - X2)
      TEMP = ((Y3 - Y2)/(X3 - X2) - (Y2 - Y1)/(X2 - X1))/(X3 - X1)
      FACT2 = (TEMP - FACT2) / (X3 - X0)
      TERM = TERM + FACT1 * FACT2
      XNTERP = TERM
      RETURN
      END
!C-----------------------------------------------------------------------
!C  SUBROUTINE XNTRP2 PERFORMS 2ND OR 1ST ORDER POLYNOMIAL INTERPOLATION
      SUBROUTINE XNTRP2(X,Y,XS,YS,N)
      real(tdp) :: XS(N),YS(N), X, Y
      IF (N.GT.2) GO TO 15
      Y=(YS(2)-YS(1))*(X-XS(1))/(XS(2)-XS(1))+YS(1)
      RETURN
    15    A=(YS(1)-YS(2))/(XS(1)-XS(2))/(XS(2)-XS(3))- &
     (YS(1)-YS(3))/(XS(1)-XS(3))/(XS(2)-XS(3))
      B=(YS(1)-YS(2))/(XS(1)-XS(2))-A*(XS(1)+XS(2))
      C=YS(1)-(A*XS(1)+B)*XS(1)
      Y=C+X*(B+A*X)
      RETURN
      END SUBROUTINE XNTRP2

end module tenserleed_intpol

module smoothing
implicit none

! f2py -m smoothing MS_smoothing.f90 -h smoothing.pyf --overwrite-signature --debug-capi
! f2py -c smoothing.pyf MS_smoothing.f90

real, parameter :: pi = 3.14159265358979323846
integer, parameter :: max_coeffs_rows = 4
integer, parameter :: max_degree = 10
! Coefficients for the MS1 filters, for obtaining a flat passband.
! The innermost arrays contain a, b, c for the fit
! kappa = a + b/(c - m) */

!data for 6th degree coefficient for flat passband
real(8), parameter :: correction_data_MS_6(3,1) = reshape((/0.001717576, 0.02437382, 1.64375/), (/3,1/))
! data for 8th degree coefficient for flat passband
real(8), parameter :: correction_data_MS_8(3,2) = reshape((/0.0043993373, 0.088211164, 2.359375,&
                                                             0.006146815, 0.024715371, 3.6359375/),&
                                                            (/3,2/))
! data for 10th degree coefficient for flat passband
real(8), parameter :: correction_data_MS_10(3,2) = reshape((/0.0011840032, 0.04219344, 2.746875,&
                                                             0.0036718843, 0.12780383, 2.7703125/),&
                                                            (/3,2/))

!data for 4th degree coefficient for flat passband
real(8), parameter :: correction_data_MS1_4(3,1) = reshape((/0.021944195, 0.050284006, 0.765625/), (/3,1/))
! data for 6th degree coefficient for flat passband
real(8), parameter :: correction_data_MS1_6(3,2) = reshape((/0.0018977303, 0.008476806, 1.2625,&
                                                             0.023064667, 0.13047926, 1.2265625/),&
                                                            (/3,2/))
! data for 8th degree coefficient for flat passband
real(8), parameter :: correction_data_MS1_8(3,3) = reshape((/0.0065903002, 0.057929456, 1.915625,&
                                                             0.0023234477, 0.010298849, 2.2726562,&
                                                             0.021046653, 0.16646601, 1.98125/),&
                                                            (/3,3/))

! data for 10th degree coefficient for flat passband
real(8), parameter :: correction_data_MS1_10(3,4) = reshape((/9.749618E-4, 0.0020742896, 3.74375,&
                                                             0.008975366, 0.09902466, 2.7078125,&
                                                             0.0024195414, 0.010064855, 3.296875,&
                                                             0.019185117, 0.18953617, 2.784961/),&
                                                            (/3,4/))

contains

subroutine MS_smoother(data, isMS1, degree, m, out_data)
    implicit none
    ! Input
    integer, intent(in) :: degree, m, isMS1
    real(8), intent(in) :: data(:)

    ! Output
    real(8), intent(out) :: out_data(size(data))

    ! Internal
    integer max_degree, m_min, radius, ncoeffs, fitlength, p
    real(8) :: coeffs(3*4) !TODO: use paramter max_coeffs_rows here
    real(8), allocatable :: extended_data(:), extended_smoothed(:), fit_weights(:), kernel(:)
    real(8) :: first_zero, beta

    ! Get coefficients from parameters above
    call get_coefficients(isMS1, degree, m, ncoeffs, coeffs)

    if (isMS1 == 1) then
        first_zero = (m+1)/(1+0.5d0*degree)
        beta = 0.65d0 + 0.35d0*exp(-0.55d0*(degree-4))
    else
        first_zero = (m+1)/(1.5d0+0.5d0*degree)
        beta = 0.7d0 + 0.14d0*exp(-0.6d0*(degree-4))
        fitlength = int(ceiling(first_zero*beta))
    end if

    fitlength = int(ceiling(first_zero*beta))
    allocate(fit_weights(fitlength))
    do p = 1, fitlength+1
        fit_weights(p) = (cos(0.5d0*pi/(first_zero*beta)*(p-1)))**2
    end do

    kernel = make_kernel(isMS1, degree, m, coeffs, ncoeffs) ! should be allocated automaticaly
    radius = size(kernel) - 1
    extended_data = extend_data(data, fit_weights, m)
    extended_smoothed = smooth_except_boundaries(extended_data, kernel)
    out_data = extended_smoothed(radius+1:radius+1+size(data))

    ! Below can be used for debugging; uncomment to print out arrays/values
    !write(*,*) "ncoeffs: ", ncoeffs
    !write(*,*) "coeffs: ", coeffs
    !write(*,*) "kernel: ", kernel
    !write(*,*) "fitlength: ", fitlength
    !write(*,*) "fit_weights: ", fit_weights
    !write(*,*) "extended_data: ", extended_data
    !write(*,*) "smooth_except_boundaies: ", extended_smoothed
    !write(*,*) "out: ", out_data
    return
end subroutine MS_smoother

pure function make_kernel(isMS1, degree, m, coeffs, ncoeffs) result(kernel)
    implicit none
    integer, intent(in) :: isMS1, degree, m, ncoeffs
    real(8), intent(in) :: coeffs(ncoeffs)

    real(8) kernel(m+1)
    real(8) sum, x, sinc_arg, k, decay
    integer nu, i, j

    sum = 0d0
    if (isMS1 == 1) then
        decay = 2 !MS: decay alpha =2: 13.5% at end without correction, 2sqrt2 sigma
        if (modulo((degree/2),2)==0) then
            nu = 2
        else
            nu = 1
        end if
    else
        decay = 4 !MS: decay alpha =2: 13.5% at end without correction, 2sqrt2 sigma
        ! nu not needed
    end if

    do i=0, m
            x = real(i)*(1d0/(m+1))
            if (isMS1 == 1) then
                sinc_arg = pi*0.5d0*(degree+2)*x ! depends on isMS1
            else
                sinc_arg = pi*0.5d0*(degree+4)*x ! depends on isMS1
            end if

            if (i==0) then
                k = 1 ! lim x->0 sin(x)/x = 1 (saved from 0/0 by l'Hopitals' rule)
            else
                k = sin(sinc_arg)/sinc_arg ! sinc = sin(x)/x
            end if
            if (isMS1 == 1) then
                do j=0, ncoeffs-1
                    k = k + coeffs(j+1)*x*sin((2*j+nu)*pi*x)
                end do
            else
                do j=0, ncoeffs-1
                    k = k + coeffs(j+1)*x*sin((j+1)*pi*x)
                end do
            end if
            k = k*(exp(-x**2*decay) + exp(-(x-2)**2*decay) + exp(-(x+2)**2*decay) - 2*exp(-decay) - exp(-9*decay))
            kernel(i+1) = k
            if (i>0) then
                sum = sum + 2*k !MS: off-center kernel elements appear twice
            else
                sum = sum + k
            end if
    end do


    !Finally normalize kernel elements
    kernel = kernel*(1/sum) ! Whole array operation
    return
end function make_kernel

subroutine get_coefficients(isMS1, degree, m, ncoeffs, coeffs)
    implicit none
    integer, intent(in) :: isMS1, degree, m

    integer, intent(out) :: ncoeffs
    real(8), intent(out) :: coeffs(3*4) !TODO: use paramter max_coeffs_rows here

    ! Internal
    real(8), allocatable :: corrForDeg(:,:)
    integer n_corr_lines, i
    real(8) :: abc(3), cm

    coeffs = 0
    if (isMS1 == 1) then ! MS1
        if (degree == 0) then
            n_corr_lines = 0
        elseif (degree == 2) then
            n_corr_lines = 0
        elseif (degree == 4) then
            n_corr_lines = 1
            allocate(corrForDeg(3,n_corr_lines))
            corrForDeg = correction_data_MS1_4
        elseif (degree == 6) then
            n_corr_lines = 2
            allocate(corrForDeg(3,n_corr_lines))
            corrForDeg = correction_data_MS1_6
        elseif (degree == 8) then
            n_corr_lines = 3
            allocate(corrForDeg(3,n_corr_lines))
            corrForDeg = correction_data_MS1_8
        elseif (degree == 10) then
            n_corr_lines = 4
            allocate(corrForDeg(3,n_corr_lines))
            corrForDeg = correction_data_MS1_10
        end if
    else ! MS
        if (degree == 0) then
            n_corr_lines = 0
        elseif (degree == 2) then
            n_corr_lines = 0
        elseif (degree == 4) then
            n_corr_lines = 0
        elseif (degree == 6) then
            n_corr_lines = 1
            allocate(corrForDeg(3,n_corr_lines))
            corrForDeg = correction_data_MS_6
        elseif (degree == 8) then
            n_corr_lines = 2
            allocate(corrForDeg(3,n_corr_lines))
            corrForDeg = correction_data_MS_8
        elseif (degree == 10) then
            n_corr_lines = 2
            allocate(corrForDeg(3,n_corr_lines))
            corrForDeg = correction_data_MS_10
        end if
    end if

    ncoeffs = n_corr_lines*3

    do i = 0, n_corr_lines-1
        abc = corrForDeg(:,i+1)
        cm = abc(3) - m
        coeffs(i+1) = abc(1) + abc(2)/(cm**3)
    end do


end subroutine get_coefficients

pure function extend_data(data, fit_weights, m) result(extended)
    implicit none
    integer, intent(in) :: m
    real(8), intent(in) :: data(:), fit_weights(:)

    !Output
    real(8), allocatable :: extended(:)

    integer fit_length, p
    real(8), allocatable :: lin_reg_x(:), lin_reg_y(:), lin_reg_weights(:)
    real(8) :: d_k(2)


    fit_length = int(min(size(fit_weights), size(data)))
    allocate(lin_reg_x(fit_length), lin_reg_y(fit_length), lin_reg_weights(fit_length))
    do concurrent (p = 1: fit_length)
        lin_reg_x(p) = p
        lin_reg_y(p) = data(p)
        lin_reg_weights(p) = fit_weights(p)
    end do
    d_k =linear_regression_weighted(lin_reg_x, lin_reg_y, lin_reg_weights)
    allocate(extended(size(data)+2*m))
    do p = 1, m
        extended(1+m-p) = d_k(1) - d_k(2)*(p-1)
    end do
    do concurrent (p = 1: fit_length)
        lin_reg_x(p) = p
        lin_reg_y(p) = data(size(data)-p+1) ! -p+1 rather than -p due to Fortran indices
        lin_reg_weights(p) = fit_weights(p) ! fit weights are of the form (cos(a*p))**2, which is symmertric thus p can be used as index
    end do
    d_k =linear_regression_weighted(lin_reg_x, lin_reg_y, lin_reg_weights)
    do p =1, m
        extended((size(data)+m+p)) = d_k(1) - d_k(2)*(p-1)
    end do
    extended(m+1: size(data)+m+1) = data
    return
end function extend_data

pure function smooth_except_boundaries(data, kernel) result(smoothed_data)
    implicit none
    real(8), intent(in) :: data(:), kernel(:)

    real(8) :: smoothed_data(size(data))

    integer radius, i, j

    smoothed_data = 0d0 ! initialization
    radius = size(kernel) -1
    do concurrent (i = radius: size(data)-radius-1)
        smoothed_data(i+1) = kernel(1)*data(i+1)
        do j = 1, size(kernel)-1
            smoothed_data(i+1) = smoothed_data(i+1) + kernel(j+1)*(data(i-j+1)+data(i+j+1))
        end do
    end do

end function  smooth_except_boundaries

pure function linear_regression_weighted(x, y, weights) result(d_k)
    implicit none
    real(8), intent(in) :: x(:), y(:), weights(:)

    !Returns
    real(8) d_k(2)

    !Internal
    real(8) :: sum_weights, sum_x, sum_y, sum_xy, sum_x2, sum_y2
    integer n

    n = size(x)
    sum_weights = sum(weights)
    sum_x = sum(x*weights)
    sum_y = sum(y*weights)
    sum_xy = sum(x*y*weights)
    sum_x2 = sum(x**2*weights)
    sum_y2 = sum(y**2*weights)

    ! Slope
    d_k(2) = (sum_xy-sum_x*sum_y*(1/sum_weights))/(sum_x2-sum_x**2*(1/sum_weights))
    ! Intercept
    d_k(1) = (sum_y-d_k(2)*sum_x)/sum_weights

end function linear_regression_weighted

end module smoothing

! Subroutines and functions for R factor calculation in ViPErLEED
!
! v0.2.3
!
! Author: Alexander M. Imre, 2021
! for license info see ViPErLEED Package

! Note: file extentsion .f90 required for f2py compatibility, but newer standard can be used.

module r_factor_new
    use interpolation
    use ieee_arithmetic
    implicit none

    contains

    

! f2py -m rfactor rfactor.f90 -h rfactor.pyf --overwrite-signature --debug-capi
! f2py -c rfactor.pyf rfactor.f90



! The equidistant final grid is defined by the array E_new with length n_E_new.  This is equivalently defined by the set of integers n_E_new, E_new_start, E_new_step.

! Experimental data may come in as arrays 


   
subroutine r_pendry_beam_y(n_E, E_step, y1, y2, id_start_1, id_start_2, n_1, n_2, V0r_shift, &
                         R_pendry, numerator, denominator, N_overlapping_points)
    ! Innermost function Rfactor_beam:
    ! INPUT: Y1, Y2, Estart1, Estart2, V0rshift -> Y1 and Y2 are already prepared (i.e. same grid steps, I(V) was previously interpolated)
    ! DOES: figure out overlap region, calculate RPe
    ! RETURNS: RPe, Number of overlapping points/ !!! -> not just R pendry for each beam, but numerator & denominator! for further calculation!!
    !

    !###############
    !INPUTS
    !###############

    !f2py intent(in) n_E
    integer, intent(in) :: n_E
    real(8), INTENT(IN) :: E_step
    integer, INTENT(IN) :: id_start_1, id_start_2
    integer, INTENT(IN) :: n_1, n_2
    !f2py intent(in) y1
    real(8), intent (in), dimension(n_E)   :: y1
    !f2py intent(in) y2
    real(8), intent (in), dimension(n_E)   :: y2
    integer, intent (in)                   :: V0r_shift
    ! outputs
    real(8), intent (out)                  :: R_pendry, numerator, denominator
    integer,  intent (out)              :: N_overlapping_points

    real(8), dimension (:), allocatable         :: y_diff, y_squared_sum

    integer :: id_min, id_max

    if (n_1 == 0 .or. n_2 == 0) then
        N_overlapping_points = 0
        numerator = 0
        denominator = 0
        R_pendry = ieee_value(real(8), ieee_signaling_nan)
    else
    
        ! V0r_shift shifts y2 by some number of grid points -> id_start_2 = id_start_2 + V0r_shift
        id_min = max(id_start_1, id_start_2 + V0r_shift)
        id_max = min(id_start_1 + n_1 - 1, id_start_2 + n_2 - 1 + V0r_shift)
        
        N_overlapping_points = id_max - id_min + 1

        allocate(y_diff(N_overlapping_points), y_squared_sum(N_overlapping_points))

        ! Shift it around

        ! Remember that indices are shifted by V0r

        y_diff=y1(id_min : id_max) - y2(id_min - V0r_shift: id_max - V0r_shift) ! difference between Y functions
        !y_diff=abs(y1(id_min : id_max))
        y_squared_sum=y1(id_min: id_max)**2 + y2(id_min - V0r_shift: id_max - V0r_shift)**2
        
        ! caclulate numerator = integral (Y1-Y2)**2 dE
        numerator = trapez_integration_const_dx(y_diff**2, E_step)
        ! calculate denominator = integral (Y1**2+Y2**2) dE
        denominator = trapez_integration_const_dx(y_squared_sum, E_step)
        
        R_pendry = numerator/denominator
    end if

    return

end subroutine r_pendry_beam_y


subroutine apply_beamset_shift(n_E, n_beams, &
    & data_1, id_start_1, n_1, &
    & data_2, id_start_2, n_2, &
    & shift, &
    & fill_outside, &
    & ierr )
    integer, INTENT(IN)         :: n_E, n_beams
    real(8), DIMENSION(n_E, n_beams), INTENT(INOUT)    :: data_1, data_2
    integer, INTENT(INOUT), DIMENSION(n_beams)         :: id_start_1, id_start_2
    integer, INTENT(INOUT), DIMENSION(n_beams)         :: n_1, n_2
    integer, INTENT(IN)         :: shift

    !f2py integer, optional :: fill_outside = 1
    integer, INTENT(IN)                     :: fill_outside

    integer, INTENT(OUT)                    :: ierr

    INTEGER, DIMENSION(n_beams) :: id_min, id_max, n_overlapp
    Integer                     ::ii
    logical                     :: fill_NaN_internal
    ! Takes two data arrays with n_E and E_start information and applies provided V0r shift
    ! The rest is filled with NaNs 

    ierr = 0

    if (fill_outside == 1) then
        fill_NaN_internal = .True.
    else if (fill_outside == 0) then
        fill_NaN_internal = .False.
    else
        ierr = 921
        RETURN
    end if

    do concurrent (ii = 1:n_beams)
        id_min(ii) = max(id_start_1(ii), id_start_2(ii) + shift)
        id_max(ii) = min(id_start_1(ii) + n_1(ii) - 1, id_start_2(ii) + n_2(ii) - 1 + shift)
        n_overlapp(ii) = id_max(ii) - id_min(ii) + 1

        id_start_1(ii) = id_min(ii)
        id_start_2(ii) = id_min(ii)
        n_1(ii) = n_overlapp(ii)
        n_2(ii) = n_overlapp(ii)

        data_1(id_min(ii) : id_max(ii), ii) = data_1(id_min(ii) : id_max(ii), ii)
        data_2(id_min(ii) : id_max(ii), ii) = data_2(id_min(ii) - shift: id_max(ii) - shift, ii)

        if (fill_NaN_internal) then
            data_1(:id_min(ii)-1, ii) = ieee_value(real(8), ieee_signaling_nan)
            data_1(id_max(ii)+1:, ii) = ieee_value(real(8), ieee_signaling_nan)
            data_2(:id_min(ii)-1, ii) = ieee_value(real(8), ieee_signaling_nan)
            data_2(id_max(ii)+1:, ii) = ieee_value(real(8), ieee_signaling_nan)
        else
            data_1(:id_min(ii)-1, ii) = 0
            data_1(id_max(ii)+1:, ii) = 0
            data_2(:id_min(ii)-1, ii) = 0
            data_2(id_max(ii)+1:, ii) = 0
        end if
        
    end do

    return
end subroutine apply_beamset_shift

subroutine r2_beam_intensity(n_E, E_step, int_1, int_2, id_start_1, id_start_2, n_1, n_2, &
    V0r_shift, R2, n_overlapping_points)

    integer, intent(in) :: n_E
    real(8), INTENT(IN) :: E_step
    integer, INTENT(IN) :: id_start_1, id_start_2
    integer, INTENT(IN) :: n_1, n_2
    !f2py intent(in) int_1
    real(8), intent (in), dimension(n_E)   :: int_1
    !f2py intent(in) int_2
    real(8), intent (in), dimension(n_E)   :: int_2
    integer, intent (in)                   :: V0r_shift
    ! outputs
    real(8), intent (out)                  :: R2
    integer,  intent (out)              :: n_overlapping_points

    real(8), dimension (:), allocatable         :: int_diff, y_squared_sum


    integer :: id_min, id_max
    real(8) :: A, c

    id_min = max(id_start_1, id_start_2 + V0r_shift)
    id_max = min(id_start_1 + n_1 - 1, id_start_2 + n_2 - 1 + V0r_shift)

    n_overlapping_points = id_max - id_min + 1

    
    A = 1/trapez_integration_const_dx(int_1(id_min: id_max)**2, E_step)

    c = trapez_integration_const_dx(int_1(id_min: id_max), E_step) / &
        trapez_integration_const_dx(int_2(id_min -V0r_shift : id_max - V0r_shift), E_step)

    R2 = A*trapez_integration_const_dx( ( int_1(id_min: id_max) - &
        c*int_2(id_min -V0r_shift : id_max - V0r_shift) )**2, &
        E_step ) / 2
    ! not entirely sure where this factor of 1/2 comes from, but it was implemented in TensErLEED


end subroutine r2_beam_intensity


subroutine r_beamset_V0r_opt_on_grid( &
        which_R, range, start_guess, fast_search, best_V0r_step, best_V0r, best_R, n_evaluated, &       
        n_E, E_step, n_beams, data_1, data_2, id_start_1, id_start_2, n_1, n_2, &
        r_beams, numerators, denominators, n_overlapping_points, &
        ierr, &
        tol_R, tol_R_2, max_fit_range)
    
    implicit none
    integer, parameter :: n_start_guesses = 3
    ! IN
    integer, intent(in) :: range(2)
    integer, INTENT(IN) :: start_guess(n_start_guesses)
    integer, INTENT(IN) :: which_r

    ! OUT
    logical, INTENT(INOUT) :: fast_search
    integer, INTENT(OUT) :: best_V0r_step
    real(8), INTENT(OUT) :: best_R, best_V0r ! best_V0r as real
    integer, INTENT(OUT) :: n_evaluated ! number of evaluated V0r values to find best
    integer, INTENT(OUT) :: ierr

    ! Internal variables used for V0r optimization
    real(8), ALLOCATABLE :: R_V0r(:), weights(:)
    integer :: n_steps
    real(8) :: fit_V0r_id
    real(8) :: fit_x_min, fit_y_min, fit_curvature
    integer, ALLOCATABLE :: V0r_step(:)
    real(8), ALLOCATABLE :: V0r_step_real(:)
    real(8) :: para_coeff(3)
    logical, ALLOCATABLE :: evaluated(:)

    ! Optionals
    !f2py real(8), optional :: tol_R = 0.00001
    real(8), INTENT(IN) :: tol_R, tol_R_2
    integer, INTENT(IN) :: max_fit_range

    integer :: i, j

    integer :: fit_range, min_fit_range
    integer :: next_step, closest_step
    integer :: worst_step
    integer :: best_id
    integer :: left, right
    integer :: closest_step_id
    real(8) :: R2
    integer :: ierr_tmp

    ! holder_arrays for passout
    integer, ALLocatable :: N_overlapping_points_V0r(:,:)
    real(8), ALLocatable :: r_beams_v0r(:,:)
    real(8), ALLOCATABLE :: numerators_V0r(:,:), denominators_V0r(:,:)


    ! Pass-through I/O for r_pendry_beamset
    !f2py integer, hidden, intent(in), depend(E_start1, E_start2), check(len(E_start1)==len(E_start2)) :: nr_beams=len(E_start1)
    integer :: n_E ! number of energy steps
    integer n_beams
    !f2py real(8), intent(in) :: E_step
    real(8) :: E_step
    !f2py real intent(in) :: data_1 (n_E, n_beams), data_2 (n_E, n_beams)
    real(8), intent(in) :: data_1 (n_E, n_beams), data_2 (n_E, n_beams)
    !f2py integer, intent(in) id_start_1
    !f2py integer, intent(in) id_start_2
    integer, intent(in)    :: id_start_1(n_beams) ,id_start_2(n_beams)
    !f2py integer, intent(in) n_1
    !f2py integer, intent(in) n_2
    integer, intent(in)    :: n_1(n_beams) ,n_2(n_beams)
    !f2py integer, intent(out) :: n_overlapping_points
    integer, intent(out) :: n_overlapping_points(n_beams)
    !f2py real(8), intent(out) :: r_beams(n_beams)
    real(8), intent(out) :: r_beams(n_beams)
    real(8), intent(out) :: numerators(n_beams), denominators(n_beams)


    ! *****************************************************************************************

    n_steps = range(2) - range(1) + 1
    
    if (n_steps .le. 5) then
        ierr = 851
        ! give back bad (impossible) R-factor as additional warning
        best_R = 999d0
        r_beams(:) = 999d0
        RETURN
    end if

    ! initialize to some value ! TODO: find a better way to deal with this
    closest_step = 0


    ALLOCATE(V0r_step(n_steps), V0r_step_real(n_steps))
    ALLOCATE(R_V0r(n_steps), weights(n_steps))
    ! Below arrays are allocated with beam index in first position, because step changes more slowly!
    ALLOCATE(r_beams_v0r(n_beams, n_steps), N_overlapping_points_V0r(n_beams, n_steps))
    ALLOCATE(numerators_V0r(n_beams, n_steps), denominators_V0r(n_beams, n_steps))
    ALLOCATE(evaluated(n_steps))

    do i = 1, n_steps
        V0r_step(i) = range(1) + i - 1
        V0r_step_real(i) = range(1) + i - 1
    end do

    ! Assign NaNs to unknown R_V0r and impossibly large value to best_R
    R_V0r = 5d3

    best_R = 5d3
    weights = 0
    evaluated = .False.

    ! If using R Pendry data must be Y function, if using R2 data must be intensities
    ! If this routine is called with the wrong which_r data may contain NaNs only. Check for that in first beam:
    if (ANY(ieee_is_nan(data_1(id_start_1(1) : id_start_1(1) + n_1(1) - 1, 1))) .or. &
        ANY(ieee_is_nan(data_2(id_start_2(1) : id_start_2(1) + n_2(1) - 1, 1))) ) then
            ierr = 702
            RETURN
    end if

    n_evaluated = 0
    fit_range = max_fit_range
    min_fit_range = max(max_fit_range - 6, 5)

    next_step = start_guess(1) - range(1) + 1

    ! if using factor R2 don't return numerators and denominators
    if (which_r == 2) then
        numerators_V0r = ieee_value(real(8), ieee_signaling_nan)
        denominators_v0r = ieee_value(real(8), ieee_signaling_nan)
    end if

    do while(fast_search)
        ! print*, "Evaluated:", n_evaluated, "next step", next_step
        if (.not. evaluated(i)) then
            if (which_R == 1) then
                call r_pendry_beamset_y(n_E, E_step, n_beams, data_1, data_2, id_start_1, id_start_2, n_1, n_2, &
                    V0r_step(i), & 
                    R_V0r(i), &
                    r_beams_v0r(:, i), &
                    numerators_V0r(:, i), denominators_V0r(:, i), &
                    N_overlapping_points_V0r(:, i), &
                    ierr_tmp)
            else if (which_R == 2) then
                call r2_beamset_intensity(n_E, E_step, n_beams, data_1, data_2, id_start_1, id_start_2, n_1, n_2, &
                    V0r_step(i), &
                    R_V0r(i), &
                    r_beams_V0r(:, i), &
                    n_overlapping_points_V0r(:, i), &
                    ierr)
            else
                ierr = 701
                RETURN
            end if
        end if
        ! Pass out possible R factor error message
        if (ierr .ne. 0) RETURN
        print*, ""
        print*, "Smart step:", V0r_step(next_step), "R = ", R_V0r(next_step)


        ! Calculate next point
        call update_best_V0r(n_steps, n_beams, best_R, best_id, R_V0r(next_step), next_step, &
            N_overlapping_points_V0r, N_overlapping_points, &
            numerators_V0r, numerators, &
            denominators_V0r, denominators, &
            r_beams_v0r, r_beams)

        evaluated(next_step) = .True.
        n_evaluated = n_evaluated + 1
        weights(next_step) = 1

        ! Do 3 guesses initially
        if (n_evaluated < 3) then
            next_step = start_guess(n_evaluated + 1) - range(1) +1
            CYCLE
        else if (n_evaluated == 3) then
            call parabola_lsq_fit(n_steps, V0r_step_real, R_V0r, weights, para_coeff, ierr)
            if (ierr .ne. 0) RETURN ! Error
            fit_curvature = 2*para_coeff(1)
            fit_x_min = -para_coeff(2)/para_coeff(1)/2
            closest_step = NINT(fit_x_min) - (range(1)) + 1

            
        else if (n_evaluated == n_steps) then
            ierr = 852
            exit
        else if (n_evaluated > 3) then
            weights = 0
            weights(next_step) = 1
        end if


        ! Decide how to proceed:
        ! *****************************************************************************************

        ! Everything withing fit_range of closest_step is taken for parabola

        do i = 0, fit_range
            if ((closest_step - i < 1) .or. (closest_step + i > n_steps)) then
                ierr = 854
                fast_search = .False.
                print*, "outside range!"
                EXIT
            end if
            if (evaluated(closest_step - i)) then
                weights(closest_step - i) = 1
            end if
            if (evaluated(closest_step + i)) then
                weights(closest_step + i) = 1
            end if
        end do

        if (.not. fast_search) EXIT

        !print*, "SUM weights", sum(weights), n_evaluated

        if (sum(weights) < 3.9) then
            if (.not. evaluated(closest_step)) then
                next_step = closest_step
                CYCLE
            end if
            do i = 1, fit_range
                if (.not. evaluated(closest_step - i)) then
                    next_step = closest_step - i
                    EXIT
                end if
                if (.not. evaluated(closest_step + i)) then
                    next_step = closest_step + i
                    EXIT
                end if
            end do
            CYCLE
        else 
            !Fit parabola to values
            call parabola_lsq_fit(n_steps, V0r_step_real, R_V0r, weights, para_coeff, ierr)
            if (ierr .ne. 0) RETURN ! Error
    
            ! perform parabola fit -> fit_V0r_id, fit_R, curvature,
            fit_curvature = 2*para_coeff(1)
            fit_x_min = -para_coeff(2)/para_coeff(1)/2
            fit_y_min = para_coeff(3) - para_coeff(2)**2/para_coeff(1)/4
    
            print*, "Expecting minimum of R =", fit_y_min, "at V0r = ", fit_x_min*E_step
    
    
            ! decide if fast search possible
            closest_step = NINT(fit_x_min) - (range(1)) + 1
            
            if ((closest_step .le. 1) .or. (closest_step .ge. n_steps) .or. (fit_curvature .le. 0.005)) then
                ! Parabola fit doesnt work...
                fast_search = .False.
                print*, "Parabola is futile!"
                print*, "curvature", fit_curvature
                exit
            end if
    
            ! Have we calculated the point closest to the predicted minimum yet?
            if (.not. evaluated(closest_step)) then
                next_step = closest_step
                CYCLE
            end if
        end if

        R2 = parabola_R_squared(n_steps, V0r_step_real, R_V0r, weights, para_coeff(1), para_coeff(2), para_coeff(3))
        print*, "Getting R^2 = ", R2


        if (R2 > tol_R) then
            ! Statisfied
            best_V0r = fit_x_min*E_step
            best_R = fit_y_min
            best_V0r_step = V0r_step(best_id)
            print*, ""
            print*, "Smart search success"
            print*, "Energy overlapp: ", sum(N_overlapping_points_V0r(:,best_id) -1)*E_step
            RETURN
        
        else if (sum(weights) < 2*fit_range + 1) then
            ! add another point in the range
            do i = 1, fit_range
                if (.not. evaluated(closest_step - i)) then
                    next_step = closest_step - i
                    EXIT
                else if (.not. evaluated(closest_step + i)) then
                    next_step = closest_step + i
                    EXIT
                end if
            end do
            CYCLE

        else if (R2 > tol_R_2) then
            ! try to limit fit_range and see if it gets better

            if (fit_range > min_fit_range) then
                fit_range = fit_range - 1
            else
                ! Minimum present, but not well behaved. Return minimum value on grid instead of prediciton.
                ierr = 856
                best_V0r = V0r_step_real(best_id)*E_step
                best_V0r_step = V0r_step(best_id)
                best_R = R_V0r(best_id)
                RETURN
            end if

        else
            !Default to brute force
            ierr = 855
            fast_search = .False.
            exit
        end if


    end do

    ! *****************************************************************************************
    ! Brute force grid - not efficient, but will always give a result
    best_id = 1
    do i = 1, n_steps
        if (.not. evaluated(i)) then
            if (which_R == 1) then
                call r_pendry_beamset_y(n_E, E_step, n_beams, data_1, data_2, id_start_1, id_start_2, n_1, n_2, &
                    V0r_step(i), & 
                    R_V0r(i), &
                    r_beams_v0r(:, i), &
                    numerators_V0r(:, i), denominators_V0r(:, i), &
                    N_overlapping_points_V0r(:, i), &
                    ierr)
            else if (which_R == 2) then
                call r2_beamset_intensity(n_E, E_step, n_beams, data_1, data_2, id_start_1, id_start_2, n_1, n_2, &
                    V0r_step(i), &
                    R_V0r(i), &
                    r_beams_V0r(:, i), &
                    n_overlapping_points_V0r(:, i), &
                    ierr)
            else
                ierr = 701
                RETURN
            end if

            evaluated(i) = .True.
            n_evaluated = n_evaluated + 1
            call update_best_V0r(n_steps, n_beams, best_R, best_id, R_V0r(i), i, &
                N_overlapping_points_V0r, N_overlapping_points, &
                numerators_V0r, numerators, &
                denominators_V0r, denominators, &
                r_beams_v0r, r_beams)

        else
            CYCLE
        end if
    end do

    ! If brute forced, report best V0r as the best step
    best_V0r_step = V0r_step(best_id)
    best_V0r = V0r_step_real(best_id)*E_step
    best_R = R_V0r(best_id)
    RETURN

end subroutine r_beamset_V0r_opt_on_grid

subroutine update_best_V0r(n_steps, n_beams, curr_best_R, curr_best_id, R, id, &
                N_overlapping_points_V0r, N_overlapping_points, &
                numerators_V0r, numerators, &
                denominators_V0r, denominators, &
                r_beams_v0r, r_pendry_beams)
    integer :: n_steps
    integer :: n_beams
    real(8), INTENT(INOUT) :: curr_best_R
    integer, INTENT(INOUT) :: curr_best_id

    real(8), INTENT(IN) :: R
    integer, INTENT(IN) :: id

    integer, INTENT(IN) :: N_overlapping_points_V0r(n_beams, n_steps)
    real(8), INTENT(IN) :: numerators_V0r(n_beams, n_steps)
    real(8), INTENT(IN) :: denominators_V0r(n_beams, n_steps)
    real(8), INTENT(IN) :: r_beams_v0r(n_beams, n_steps)

    integer, INTENT(OUT) :: N_overlapping_points(n_beams)
    real(8), INTENT(OUT) :: numerators(n_beams)
    real(8), INTENT(OUT) :: denominators(n_beams)
    real(8), INTENT(OUT) :: r_pendry_beams(n_beams)


    if (R < curr_best_R) then
        curr_best_R = R
        curr_best_id = id
        N_overlapping_points = N_overlapping_points_V0r(:, id)
        numerators = numerators_V0r(:, id)
        denominators = denominators_V0r(:, id)
        r_pendry_beams = r_beams_v0r(:, id)
    end if
    RETURN
end subroutine update_best_V0r

subroutine parabola_lsq_fit(n,x,y, w, B, ierr)
    integer, INTENT(IN) :: n 
    real(8), INTENT(IN) :: x(n), y(n), w(n)

    real(8), INTENT(OUT) :: B(3,1)
    integer,  INTENT(OUT):: ierr

    real(8) :: s_x, s_x2, s_y, s_x3, s_x4, s_xy, s_x2y
    real(8) :: A(3,3)
    integer :: LAPACK_info, i, ipiv(3)
    integer :: WORK(18)
    real(8) :: n_real

    n_real = n
    s_x     = 0
    s_x2    = 0
    s_y     = 0
    s_x3    = 0
    s_xy    = 0
    s_x4    = 0
    s_x2y   = 0

    A = 0
    B = 0

    do i = 1, n
        A(1,1) = A(1,1) + w(i)*x(i)**4
        A(1,2) = A(1,2) + w(i)*x(i)**3
        A(1,3) = A(1,3) + w(i)*x(i)**2
        A(2,3) = A(2,3) + w(i)*x(i)
        A(3,3) = A(3,3) + w(i)

        B(1,1) = B(1,1) + w(i)*y(i)*x(i)**2
        B(2,1) = B(2,1) + w(i)*y(i)*x(i)
        B(3,1) = B(3,1) + w(i)*y(i)

    end do
    ! Impose symmetry afterwards and save statements in loop
    A(2,1) = A(1,2)
    A(2,2) = A(1,3)
    A(3,1) = A(1,3)
    A(3,2) = A(2,3)

    !> Call Lapack subroutine
    call DSYSV('U', 3, 1, A, 3, ipiv, b, 3, work, 18, LAPACK_info)
    if (LAPACK_info .ne. 0) ierr = 860


end subroutine parabola_lsq_fit

function parabola(x, a, b, c) result(y)
    real(8), INTENT(IN)  :: x
    real(8), INTENT(IN)  :: a, b, c
    real(8) :: y

    y = a*(x**2) + b*x + c
    RETURN
end function parabola

function parabola_R_squared(n, x, y, w, a, b, c) result(R_squared)
    integer, INTENT(IN) :: n
    real(8), INTENT(IN) :: x(n), y(n), w(n)
    real(8), INTENT(IN) :: a, b, c
    real(8) :: R_squared

    real(8) :: y_tmp, sum_weights, y_avg
    integer :: i
    real(8) :: SS_res, SS_tot

    y_avg = sum(y*w)/sum(w)

    R_squared = 0
    SS_res = 0
    SS_tot = 0

    do i = 1, n
        y_tmp = parabola(x(i), a, b, c)
        SS_res = SS_res + w(i)*((y(i) - y_tmp)**2)
        SS_tot = SS_tot + w(i)*((y(i) - y_avg)**2)
    end do
    
    R_squared = 1 - SS_res/SS_tot

end function parabola_R_squared


subroutine r_pendry_beamset_y(n_E, E_step, n_beams, y1, y2, id_start_1, id_start_2, n_1, n_2, V0r_shift, &
    r_pendry_weighted, r_pendry_beams, numerators, denominators, n_overlapping_points, ierr)
    !Rfactor_beamset:
    !INPUT: set of arrays Y1, Y2, Estart1, Estart2, V0rshift, beamtypes -> calls the above in a loop over beams
    !DOES: call above, average based on overlapping points, also split into types ("integer/fractional")
    !RETURNS: array RPe [overall and for each beamtype]
    implicit none

    !###############
    !INPUTS
    !###############
    !f2py integer, hidden, intent(in), depend(E_start1, E_start2), check(len(E_start1)==len(E_start2)) :: nr_beams=len(E_start1)
    integer :: n_E ! number of energy steps
    integer n_beams
    !f2py real(8), intent(in) :: E_step
    real(8) :: E_step
    !f2py real intent(in) :: y1 (n_E, n_beams), y2 (n_E, n_beams)
    real(8), intent(in) :: y1 (n_E, n_beams), y2 (n_E, n_beams)
    !f2py integer, intent(in) id_start_1
    !f2py integer, intent(in) id_start_2
    integer, intent(in)    :: id_start_1(n_beams) ,id_start_2(n_beams)
    !f2py integer, intent(in) n_1
    !f2py integer, intent(in) n_2
    integer, intent(in)    :: n_1(n_beams) ,n_2(n_beams)
    !f2py integer, intent(out) :: n_overlapping_points
    integer, intent(out) :: n_overlapping_points(n_beams)
    !f2py real(8), intent(out) :: r_pendry_beams(n_beams), r_pendry_weighted
    real(8), intent(out) :: r_pendry_beams(n_beams), r_pendry_weighted
    real(8), intent(out) :: numerators(n_beams), denominators(n_beams)
    !f2py integer, intent(in)::  V0r_shift
    integer, intent(in) :: V0r_shift

    ! Error code
    integer, intent(out):: ierr

    ! temporay variables used in subroutine
    integer i
    ! Sum variables for numerator and denominator
    real(8) num_sum, den_sum

    ierr = 0

    ! iterate over beams and call subroutine r_factor_beam
    do i=1 , n_beams
        call r_pendry_beam_y(n_E, E_step, y1(:, i), y2(:, i), id_start_1(i), id_start_2(i), n_1(i), n_2(i), V0r_shift, &
            r_pendry_beams(i), numerators(i), denominators(i), n_overlapping_points(i))
    end do

    !> If any beam R-factor is reported as NaN, denominator and numerator will be set to 0 - thus sum still works regardless
    !! However, we need to watch out for the case of numerator/denominator being NaNs. (This may be caused by the intensity being constant 0.)

    !> Sum numerators, denominators, r_pendry_beams because if any contains a NaN or +/-Inf, the sum will too
    if (.not.((ALL(ieee_is_normal(numerators + denominators + r_pendry_beams))))) then
        ! Can still calcuate an R factor, but it may be unsable. Give back R and warning
        ierr = -812
        ! initialize sum variables
        num_sum = 0
        den_sum = 0

        do i=1, n_beams
            if ((ieee_is_normal(numerators(i) + denominators(i) + r_pendry_beams(i)))) then
                num_sum = num_sum + numerators(i)
                den_sum = den_sum + denominators(i)
            end if
        end do

        r_pendry_weighted = num_sum/den_sum

    else
        r_pendry_weighted = sum(numerators)/sum(denominators)
    end if

    return
end subroutine r_pendry_beamset_y

subroutine r2_beamset_intensity(n_E, E_step, n_beams, int_1, int_2, id_start_1, id_start_2, n_1, n_2, V0r_shift, &
    r2_weighted, r2_beams,  n_overlapping_points, ierr)

    !###############
    !INPUTS
    !###############
    !f2py integer, hidden, intent(in), depend(E_start1, E_start2), check(len(E_start1)==len(E_start2)) :: nr_beams=len(E_start1)
    integer :: n_E ! number of energy steps
    integer n_beams
    !f2py real(8), intent(in) :: E_step
    real(8) :: E_step
    real(8), intent(in) :: int_1 (n_E, n_beams), int_2 (n_E, n_beams)
    integer, intent(in)    :: id_start_1(n_beams) ,id_start_2(n_beams)
    integer, intent(in)    :: n_1(n_beams) ,n_2(n_beams)
    !f2py integer, intent(out) :: n_overlapping_points
    integer, intent(out) :: n_overlapping_points(n_beams)
    real(8), intent(out) :: r2_beams(n_beams), r2_weighted
    !f2py integer, intent(in)::  V0r_shift
    integer, intent(in) :: V0r_shift

    integer, intent(out):: ierr

    ! temporay variables used in subroutine
    integer i
    real(8) temp_num, temp_denom

    ierr = 0

    ! iterate over beams and call subroutine r_factor_beam
    do i=1 , n_beams
        call r2_beam_intensity(n_E, E_step, int_1(:, i), int_2(:, i), id_start_1(i), id_start_2(i), n_1(i), n_2(i), V0r_shift, &
            r2_beams(i), n_overlapping_points(i))
    end do

    if (ANY(ieee_is_nan(r2_beams))) then
        r2_weighted = ieee_value(real(8), ieee_signaling_nan)
        ierr = 811
        RETURN
    end if
    
    ! factro E_step in numerator and denominator cancels out
    ! we use (n_overlapping_points - 1) for the range since 1 overlapping point would mean energy interval of 0
    r2_weighted = sum(r2_beams*(n_overlapping_points - 1))/(sum(n_overlapping_points - 1))

    return
end subroutine r2_beamset_intensity


subroutine Rfactor_v0ropt(opt_type, min_steps, max_steps, nr_used_v0)
    !Rfactor_v0ropt:
    !INPUT: same as above, but with v0rmin/v0rmax, maybe v0rstep, optimization_type
    !DOES: V0r optimization with Rfactor_beamset, either as loop over grid, or parabola
    !RETURNS: array RPe [overall and for each beamtype], V0r_shift_optimum
    implicit none
    integer, intent(in) :: opt_type, min_steps, max_steps
    integer, intent(out) :: nr_used_v0

    !integer beamtypes(:)

    real(8) V0, R_Pe_V0
    ! Decide which optimization is used
    nr_used_v0 = 0 ! initialize to 0

    !> For grid search: V0 will be sampled on an equally spaced grid in range (V0_min, V0_max) with max_steps steps.
    !! For  example, with values V0_min = 2, V0_max = 5 and max_steps = 10, the sampled points would be:
    !! 2.0, 2.5, 3.0, 3.5, 4.0, 4.5, 5.0
    !! The optional paramter min_steps is unused in this case.
    !!
    !! For parabola search: V0 will initially be sampled in three points (V0_min, V0_max and (V0_min + V0_max)/2),
    !! then an attempt is made to fit a parbola of the form R(V0) = a*V0**2 + b*V0 + c. If the curvature of the parabola
    !! is negative, subsequent V0s are choosen close to the predicted minimum and such as to test the fit. The
    !! optimization will stop if the resultant R-factor has converged (criterion V0_conv) though at least
    !! min_steps values of V0 are evaluated. If the curvature of the parabola is positive, or the fit of the parabola
    !! becomes continually worse the optimization defaults to sampling a grid. (Similar as above, though already
    !! evaluated values will not be discarded).

    if (opt_type == 0) then
    ! optimize grid
    elseif (opt_type == 1) then
    ! optimize with parabola, uses function parabolic_optimize
    end if

    ! Calculate next V0

    ! Calculate R factor, check if converged
    !call Rfactor_beamset(y1, y2, sizes_y1, sizes_y2, E_start1, E_start2, nr_beams, E_step, V0, &
    !                     beamtypes, R_Pe_V0, R_Pe_beams, N_overlapping_points)

    RETURN
end subroutine Rfactor_v0ropt

subroutine alloc_beams_arrays( &
    n_beams, &
    n_e_grid_out, &
    e_start_beams_out, &
    n_e_beams_out, &
    beams_out_array, &
    deriv_y_out_array, &
    ierr &
    )
    !> Allocates arrays of the right size to be used by prepare_beams
    !!
    !! Allocation of arrays is bad for performance, so arrays should be reused where possible.
    !! For the r-factor calculation we need to interpolate the beams and calculate the Y-function
    !! via the derivative. These operations reqire relatively large arrays that are only used once or twice. 
    !! By reusing some of the arrays, we can save time.
    !!
    !! Parameters
    !! ----------
    !! n_beams: int
    !! Number of beams.
    !!
    !! n_e_grid_out: int
    !! Number of energies after interpolation.
    !!
    !! Returns
    !! -------
    !! beams_out_array: array of float
    !! Float array for interpolated beams. Initialized to NaNs.
    !!    
    !! deriv_y_out_array : array of float
    !! Float array to hold derivatives of beams (may subsequently be overwritten by the Y-function). Initalized to NaNs.
    !!
    !! e_start_beams_out:  array of int
    !! Integer array for the start positions of beams. Initilaized to NaNs.
    !!
    !! n_e_beams_out: array of int
    !! Integer array for the number of values for each beams. Initilaized to NaNs.

    ! Input parameters
    integer, intent(in) :: n_beams
    integer, intent(in) :: n_e_grid_out
    
    ! Return values
    integer, intent(out), dimension(n_beams) :: e_start_beams_out
    integer, intent(out), dimension(n_beams) :: n_e_beams_out
    real(8), intent(out), dimension(n_e_grid_out, n_beams) :: beams_out_array
    real(8), intent(out), dimension(n_e_grid_out, n_beams) :: deriv_y_out_array
    integer, intent(out) :: ierr

    ! Perform check if NaNs are properly recognized
    ierr = test_compilation()

    ! Assign NaNs of matching type for initalization
    beams_out_array(:,:) =   ieee_value(real(8), ieee_signaling_nan)
    deriv_y_out_array(:,:) = ieee_value(real(8), ieee_signaling_nan)

    ! NaNs are not possible for integers, so set `start` to  max and `n` to 0
    e_start_beams_out(:) = n_e_grid_out - 1
    n_e_beams_out(:) =     0

end subroutine alloc_beams_arrays


subroutine prepare_beams(n_beams, n_E_in, E_grid_in, intensities, E_start_beams, n_E_beams, &
                         deg, &
                         n_derivs, &
                         n_E_out, E_grid_out, &
                         E_start_beams_out, &
                         n_E_beams_out, &
                         intpol_intensity, &
                         intpol_derivative, &
                         ierr)
    !Prepare_beams:
    !INPUT: array[I, E_min, E_step, NE], E_grid_step, averaging_scheme, smoothing?, E_min, E_max
    !Probably call several functions... see existing PREEXP, similar!
    !RETURNS: array of Y

    ! should this thing even return the Y function values ??

    !###############
    !INPUTS
    !###############
    ! Sizes
    integer, intent(in)                          :: n_beams          ! number of beams
    !f2py integer, intent(in) :: n_beams
    integer, INTENT(IN)                          :: n_E_in           ! number of energy values in the input
    !f2py integer, intent(hide), depend(E_grid_in) :: n_E_in=shape(E_grid_in,0)
    integer, INTENT(IN)                          :: n_E_out          ! number of energy values in the input
    !f2py integer, intent(hide), depend(E_grid_out) :: n_E_out=shape(E_grid_out,0)

    ! Operation information
    !f2py intent(in) :: deg
    integer, INTENT(IN) :: deg ! Degree of interpolation to use
    integer, INTENT(IN) :: n_derivs ! How many derivatives to calculate (0 or 1)

    ! Energy grids
    real(8), INTENT(IN)                         :: E_grid_in(n_E_in) ! Input energy grid
    real(8), INTENT(IN)                         :: E_grid_out(n_E_out) ! Output energy grid

    !> Intensities is a rectangular array with values for each beam at each possible energy, though values will unused if the beam does not have data over the entire
    !! energy range. The array E_start_beams determines the index of the first used energy, the array n_E_beams determines the number of the number of
    !! energy steps to used by the beam. Gaps in the beam are not allowed here, but they can be implemented externally using the averaging functionalities.
    
    !! Input Data
    integer, intent(in)                          :: E_start_beams(n_beams) ! First energy step to be used for the beam
    integer, intent(in)                          :: n_E_beams(n_beams) ! Number of energy steps to use for the beam
    real(8), intent(in)                          :: intensities(n_E_in, n_beams) ! Beam intensities - input data

    real(8), intent(inout) :: intpol_intensity(n_E_out, n_beams)
    real(8), intent(inout) :: intpol_derivative(n_E_out, n_beams)


    !f2py integer, intent(inout), dimension(n_beams) :: E_start_beams_out
    integer, INTENT(inOUT) :: E_start_beams_out(n_beams) ! First energy step for each beam of the interpolated data
    !f2py integer, intent(inout), dimension(n_beams):: n_E_beams_out
    integer, INTENT(inOUT) :: n_E_beams_out(n_beams) ! Number of energy steps for each beam of the interpolated data

    integer, INTENT(OUT) :: ierr

    !###############
    ! Internal
    !###############
    integer :: beams_max_id_in(n_beams)
    integer :: beams_max_id_out(n_beams)

    integer :: min_index, max_index

    integer :: max_n_knots, max_nt, max_LHS_rows
    integer :: n_knots_beams(n_beams), nt_beams(n_beams), LHS_rows_beams(n_beams)
    real(8), ALLOCATABLE :: knots(:,:), LHS(:,:,:), coeffs(:,:)


    real(8) :: min_intensity_beam

    integer :: ierrs(n_beams)

    integer :: ii, jj ! Loop indices

    ierr = 0
    ierrs = 0

    beams_max_id_in = E_start_beams + n_E_beams - 1

    !> ###############
    !! Limit range of beams
    !! ###############
    !! Assumes, experimental beams are recorded on the same energy grid already. This should always be the case.
    !! Thus only the information of E_min and n_E are required for each beam

    
    min_index = 1
    max_index = n_E_in
    

    ! can not set to NaNs because integer
    E_start_beams_out(:) = n_E_out
    n_E_beams_out(:) = 0 

    ! what does this do again exactly? 
    do concurrent( ii=1: n_beams)
        ! Set out beam indices & length
        E_start_beams_out(ii) = find_grid_correspondence( &
            E_grid_in(E_start_beams(ii)), &
            n_E_out, &
            E_grid_out, &
            1 &
        )

        beams_max_id_out(ii) = find_grid_correspondence( &
            E_grid_in(beams_max_id_in(ii)), &
            n_E_out, &
            E_grid_out, &
            E_start_beams_out(ii) &
        ) - 1

        n_E_beams_out(ii) = beams_max_id_out(ii) - E_start_beams_out(ii) + 1
        ! compensate for over-estimation
        n_E_beams_out(ii) = min(n_E_beams_out(ii), n_E_out - E_start_beams_out(ii) + 1)
        beams_max_id_out(ii) = n_E_beams_out(ii) + E_start_beams_out(ii) - 1
        
    end do

    !> Debug check - hopefully can be removed now?
    do ii = 1, n_beams !> @TODO urgent: this can still fail somehow!!
        if (E_grid_in(beams_max_id_in(ii)) < E_grid_out(beams_max_id_out(ii))) then
            print*, "issue size out - beam", ii
            print*, E_grid_in(beams_max_id_in(ii)), E_grid_out(beams_max_id_out(ii)) 
        end if
        if (E_grid_in(E_start_beams(ii))>E_grid_out(E_start_beams_out(ii))) then
            print*, "issue size in - beam", ii
        end if
    end do


    !> ###############
    !!  Smoothing
    !! ###############
    !!
    !!  Smoothing is not (yet) implemented.
    !!
    !!  This is a tricky issue, because excessive smoothing strongly affects the R-factor, so you want to avoid over-smoothing at all cost.
    !!  We expect the experimental data to come in from the beam-extraction already pre-smoothed. If we implement an additional later smoothing here,
    !!  it only makes sense to do it equally on experimental and theoretical data. Thus, both should use the same smoothing kernel and probably not 
    !!  use a smoothing parameter larger than ~6 eV.


    !###############
    ! Interpolation on new grid
    !###############

    !> How to deal with coeffs array? - size depends on deg:
    !! size of coeffs is nt= n_knots - deg -1 = n + 2*deg -deg -1 = n + deg -1 
    !! where max(n) is the number of datapoints in, i.e. n_E_in. Thus max(nt) = n_E_in + deg + 1.
    !! Allocating coeffs with size (n_E_in + deg) should therefor cover all possible beam sizes. Unfortunately, we need to keep track of the number of coeffs per beam in an array though.


    call perform_checks(n_E_in, E_grid_in(min_index:max_index), n_E_out, E_grid_out, ierr)
    if (ierr .ne. 0) RETURN

    call get_array_sizes(n_E_in, deg, max_n_knots, max_nt, max_LHS_rows)
    Allocate(knots(max_n_knots+1, n_beams), LHS(max_LHS_rows+1, max_nt+1, n_beams), coeffs(max_nt+1, n_beams))
    
    do ii= 1,n_beams

        !> Any beam that has not enough datapoints is unusable for interpolation etc.
        !! Therefore we reduce number of points to 0 and fill with NaNs
        if (n_E_beams(ii) <= 2*deg+1) then
            intpol_intensity(:, ii) = ieee_value(real(8), ieee_signaling_nan)
            n_E_beams_out(ii) = 0
            ierr = -703
            CYCLE
        end if

        
        call get_array_sizes(n_E_beams(ii), deg, n_knots_beams(ii), nt_beams(ii), LHS_rows_beams(ii))


        call single_calc_spline(&
            n_E_beams(ii), &
            E_grid_in(E_start_beams(ii) : beams_max_id_in(ii)), &
            intensities(E_start_beams(ii) : beams_max_id_in(ii), ii), &
            deg, &
            n_knots_beams(ii), nt_beams(ii), LHS_rows_beams(ii), &
            knots(1:n_knots_beams(ii), ii), &
            coeffs(1:nt_beams(ii), ii), &
            ierrs(ii))
        ! !Interpolate intensitites
        !     print*, "ierr", ierr
        !     print*, "First and last intensity in"
        !     print*, intensities_in(E_start_beams(i),i)
        !     print*, intensities_in(E_start_beams(i) + n_E_beams(i) - 1, i)
        !     print*, "Any NAN?", ANY(ieee_is_nan(intensities_in))
        !     print*, "First and last knot"
        !     print*, knots(1,i)
        !     print*, knots(n_knots_beams(i), i)
        !     print*, "n_knots, nt, deg, LHS_rows", n_knots_beams(i), nt_beams(i), deg, LHS_rows_beams(i)
 

        call single_interpolate_coeffs_to_grid( &
            n_knots_beams(ii), knots(1:n_knots_beams(ii), ii), nt_beams(ii), coeffs(1:nt_beams(ii), ii), &
            deg, &
            n_E_beams_out(ii), &
            E_grid_out(E_start_beams_out(ii) : beams_max_id_out(ii)), &
            0, &
            intpol_intensity(E_start_beams_out(ii) : beams_max_id_out(ii), ii))

        ! If interpolated intensity dropy below 0, set to zero
        ! This must be limited to the correct indices - otherwise it will overwrite the Nans outside!
        intpol_intensity(E_start_beams_out(ii): beams_max_id_out(ii), ii) = &
            max(intpol_intensity(E_start_beams_out(ii): beams_max_id_out(ii), ii), 0.d0)

        if (ierrs(ii) .ne. 0 )then
            ierr = ierrs(ii)
        end if
    end do

    !> Derivates may be skipped if we want to calculate R2 or just plot interpolated intensities
    if (n_derivs == 1) then
        do ii= 1,n_beams
            !> Also here there may be beams with an invalid number of datapoints
            if (n_E_beams(ii) <= 2*deg+1) then
                !> Just assign deriv NaNs and cycle, since this must have been dealt with already above
                intpol_derivative(:, ii) = ieee_value(real(8), ieee_signaling_nan)
                ierr = -703
                CYCLE
            end if 

            !> 1st derivative of interpolated beams
            call single_interpolate_coeffs_to_grid( &
            n_knots_beams(ii), knots(1:n_knots_beams(ii), ii), nt_beams(ii), coeffs(1:nt_beams(ii), ii), &
            deg, &
            n_E_beams_out(ii), &
            E_grid_out(E_start_beams_out(ii) : beams_max_id_out(ii)), &
            1, &
            intpol_derivative(E_start_beams_out(ii) : beams_max_id_out(ii), ii))

        end do

    else if (n_derivs == 2) then
        ! 2nd deriv not implemented yet
        ierr = 704
    else
        !> Error because more derivatives were requested than are implemented
        ierr = 703
    end if

    return
end subroutine prepare_beams

subroutine pendry_y_beamset( &
    n_beams, &
    n_data, &
    intensities, &
    deriv_y_func, &
    beams_id_start, &
    beams_n_e, &
    v0i &
)
    !> Calculates the Pendry Y function for a given beamset from the intensities and first derivative.
    !! The Y function is saved into the array that contained the derivative overwriting it in the process.

    ! Input parameters
    integer, intent(in) :: n_beams
    integer, intent(in) :: n_data
    real(8), intent(in), dimension(n_data, n_beams) :: intensities
    integer, intent(in), dimension(n_beams) :: beams_id_start
    integer, intent(in), dimension(n_beams) :: beams_n_e
    real(8), intent(in) :: v0i

    ! IN-OUT value
    real(8), intent(inout), dimension(n_data, n_beams) :: deriv_y_func

    ! temporary variables
    integer, dimension(n_beams) :: beams_max_id
    integer :: ii

    beams_max_id = beams_id_start + beams_n_e - 1 ! count including startpoint

    do ii = 1,n_beams
        call pendry_y( &
            beams_n_e(ii), &
            intensities(beams_id_start(ii):beams_max_id(ii), ii), &
            deriv_y_func(beams_id_start(ii):beams_max_id(ii), ii), &
            v0i &
            )
    end do

end subroutine pendry_y_beamset


pure subroutine find_index_on_new_grid(n_E_in, E_in, n_E_out, E_out, id_start_in, n_steps_in,&
                                  id_start_out, n_steps_out)
    integer, INTENT(IN) :: n_E_in, n_E_out
    real(8), INTENT(IN) :: E_in(n_E_in), E_out(n_E_out)
    integer, INTENT(IN) :: id_start_in, n_steps_in

    integer, INTENT(OUT) :: id_start_out, n_steps_out

    integer :: id_end_in, id_end_out

    id_end_in = id_start_in + n_steps_in
    id_start_out = min(1, find_interval(E_out, n_E_out, 0, E_in(id_start_in), 1, 0))
    id_end_out = max(n_E_out, find_interval(E_out, n_E_out, 0, E_in(id_start_out), 1, 0))
    n_steps_out = id_end_out - id_start_out
    RETURN
end subroutine find_index_on_new_grid

pure integer function find_grid_correspondence(value, n_steps, steps, min_bound) result(interval)
    ! returns the index of the step lower than value
    real(8), INTENT(IN) :: value
    integer, INTENT(IN) :: n_steps
    real(8), INTENT(IN) :: steps(n_steps)
    integer, INTENT(IN) :: min_bound

    integer :: i

    interval = min_bound

    do i = min_bound, n_steps
        if (steps(i) < value) then
            interval = interval + 1
        else
            RETURN
        end if
    end do
    RETURN
end function find_grid_correspondence


subroutine avg_reo_disc(n_beams_in, n_beams_out, n_E, scheme, min_len, &
    intensities, beam_start, beam_n, &
    ierr)
    !> Average, reorder and discard beams according to scheme
    !! scheme is an array of integers between 0 and n_beams_out
    !! beams are averaged into the 
    !! For any beam with scheme == 0, the beam is discarded.
    integer, INTENT(IN) :: n_beams_in
    integer, INTENT(IN) :: n_beams_out
    integer, INTENT(IN) :: n_E
    integer, INTENT(IN) :: min_len
    real(8), INTENT(INOUT) :: intensities(n_E, n_beams_in)
    integer, INTENT(INOUT) :: scheme(n_beams_in)
    integer, INTENT(INOUT) :: beam_start(n_beams_in)
    integer, INTENT(INOUT) :: beam_n(n_beams_in)


    real(8) :: intensities_in(n_E,  n_beams_in)
    integer :: beam_start_in(n_beams_in)
    integer:: beam_n_in(n_beams_in)
    integer, INTENT(OUT) :: ierr

    integer :: i,j
    integer :: avg_counter(n_beams_out)

    intensities_in = intensities
    beam_start_in = beam_start
    beam_n_in = beam_n

    beam_start(:) = 0
    beam_n(:) = n_E

    !> Adjust beam length if necessary...
    do i = 1, n_beams_out
        do j = 1, n_beams_in
            if(scheme(j)==i) then
                if (beam_start_in(j) > beam_start(i)) then
                    beam_start(i) = beam_start_in(j)
                end if 
                if (beam_start(i) + beam_n(i) > beam_start_in(j) + beam_n_in(j)) then
                    beam_n(i) = beam_start_in(j) + beam_n_in(j) - beam_start(i)
                end if
            end if
        end do
    end do

    ! Decreasing the beam lengths may have made some beams unviable for calculations...
    do j = 1, n_beams_in
        if (beam_n(j) < min_len) then
            scheme(j) = 0
            beam_n(i) = 0 ! this beam is now considered to contain no data
            !ierr = 211
        end if
    end do

    intensities(:,:) = 0.d0

    avg_counter(:) = 0
    ! Average per scheme
    do i = 1, n_beams_out
        do j = 1, n_beams_in
            if(scheme(j)==i) then
                intensities(:,i) = intensities(:,i) + intensities_in(:,j)
                avg_counter(i) = avg_counter(i) + 1
            end if
        end do
        ! Divide by nr beams if more than one
        if (avg_counter(i) > 0) then
            intensities(:,i) = intensities(:,i)/avg_counter(i)
        end if
    end do
    RETURN
end subroutine avg_reo_disc

subroutine range_index_from_Energy(E_min_current, NE_in, E_step, E_min_cut, E_max_cut, new_start_stop_step)
    integer, intent(in) :: NE_in
    real(8), intent(in) :: E_min_current, E_min_cut, E_max_cut, E_step

    integer , intent(out) :: new_start_stop_step(3)

    real(8) :: old_max, new_max, new_min

    old_max = E_min_current + E_step*NE_in
    new_max = min(E_max_cut, old_max)
    new_min = max(E_min_current, E_min_cut)

    new_start_stop_step(3) = floor((E_max_cut-E_min_cut)/E_step) ! typecast to integer; will cut off float...

    new_start_stop_step(1) = (E_min_cut - E_min_current)/E_step
    new_start_stop_step(2) = new_start_stop_step(1) + new_start_stop_step(3)
    return
end subroutine range_index_from_Energy



! Routines for working with rfactors

subroutine r_beamtype_grouping(which_r, &
        n_beams, r_beams, numerators, denominators, n_overlapping_points, &
        n_groups, grouping, r_factor_groups, n_overlapping_points_groups, ierr)

    integer, INTENT(IN) :: which_r
    integer, INTENT(IN) :: n_beams
    real(8), INTENT(IN) :: r_beams(n_beams)
    real(8), INTENT(IN) :: numerators(n_beams)
    real(8), INTENT(IN) :: denominators (n_beams)
    integer, INTENT(IN) :: n_overlapping_points(n_beams)

    integer, INTENT(IN) :: n_groups
    integer, INTENT(IN) :: grouping(n_beams)

    real(8), INTENT(OUT) :: r_factor_groups(n_groups)
    integer, INTENT(OUT) :: ierr

    integer, INTENT(OUT) :: n_overlapping_points_groups(n_groups)

    integer :: group, i
    real(8) :: num(n_groups), denom(n_groups), r2_group(n_groups)

    ierr = 0

    if (ANY(grouping < 0) .or. ANY(grouping > n_groups)) then
        ierr = 902
        RETURN
    end if

    if (which_r == 1) then ! R Pendry
        ! initialize
        num = 0
        denom = 0
        n_overlapping_points_groups = 0

        do i = 1, n_beams
            group = grouping(i)
            if (group == 0) CYCLE
            num(group) = num(group) + numerators(i)
            denom(group) = denom(group) + denominators(i)
            n_overlapping_points_groups(group) = n_overlapping_points_groups(group) + n_overlapping_points(i)
        end do

        do group = 1, n_groups
            if (abs(denom(group)) .ge. 1e-10) then
                r_factor_groups(group) = num(group)/denom(group)
            else
                r_factor_groups(group) = ieee_value(real(8), ieee_signaling_nan)
                ierr = -903
            end if 
        end do

    else if (which_r == 2) then ! R2
        do i = 1, n_beams
            group = grouping(i)
            if (group == 0) CYCLE
            n_overlapping_points_groups(group) = n_overlapping_points_groups(group) + n_overlapping_points(i) - 1
            r2_group(group) = r2_group(group) + r_beams(i)*(n_overlapping_points(i) - 1)
        end do

        do group = 1, n_groups
            if (n_overlapping_points_groups(group) .ge. 0) then ! avoid division by 0
                r_factor_groups(group) = r2_group(group)/n_overlapping_points_groups(group)
            else
                r_factor_groups(group) = ieee_value(real(8), ieee_signaling_nan)
                ierr = -904
            end if
        end do

    else
        ierr = 701
        RETURN
    end if

end subroutine r_beamtype_grouping 




! Library functions    

!> @TODO: optimize; could be made elemental but f2py compiler with gfortran won't let you... 
pure subroutine pendry_y(n_data, intensity, deriv_y_func, v0i)
    integer, intent(in) :: n_data
    real(8), intent(in) :: intensity(n_data)
    real(8), intent(inout) :: deriv_y_func(n_data)
    real(8), intent(in) :: v0i

    ! Derivative is overwritten in this operation
    deriv_y_func = intensity*deriv_y_func / (intensity*intensity + v0i*v0i*deriv_y_func*deriv_y_func)

end subroutine pendry_y


pure function trapez_integration_const_dx(f, dx) result(integral)
    implicit none
    real(8), intent(in)    :: f(:)
    real(8), intent(in)    :: dx
    real(8) integral
    integer n

    n = size(f)
    integral = 0
    integral = sum(f(1:n-1)+f(2:n))*dx/2
    return
end function trapez_integration_const_dx


! Compatibility functions
subroutine translate_evaluation_grid(e_min, e_max, EINCR, VINCR, V0RR, V01, V02, &
    n_E, energies, E_step)

    ! e_min != EMIN, e_max != EMAX
    real(4), INTENT(IN) :: e_min, e_max, EINCR, VINCR
    real(4), INTENT(IN) :: V0RR, V01, V02

    integer, INTENT(OUT) :: n_E
    real(8), INTENT(OUT), ALLOCATABLE :: energies(:)
    real(8), INTENT(OUT) :: E_step

    integer i
    real(8) :: min_tmp, max_tmp

    E_step = real(ABS(MIN(EINCR, VINCR)), 8)
    ! V01 and V02 need to be considered, because we want to keep extra data for V0r shifts
    min_tmp = e_min + real(-V0RR + V01, 8)
    max_tmp = e_max + real(-V0RR + V02, 8) + E_step

    n_E = int((max_tmp - min_tmp)/E_step)

    allocate(energies(n_E))

    !print*, size(energies)

    do i = 1, n_E
        energies(i) = min_tmp + (i-1)*E_step
    end do
    RETURN
end subroutine translate_evaluation_grid


subroutine translate_exp(n_beams, MNGP, NEE, EE, AE, &
    n_E, exp_grid, E_start_beams, n_E_beams, intensities)
    
    integer, INTENT(IN) :: n_beams
    integer, INTENT(IN) :: MNGP
    integer, INTENT(IN) :: NEE(n_beams)
    real(4), INTENT(IN) :: EE(n_beams, MNGP), AE(n_beams, MNGP)
    
    integer, INTENT(OUT) :: n_E
    integer, INTENT(OUT) :: n_E_beams(n_beams), E_start_beams(n_beams)
    real(8), INTENT(OUT), ALLOCATABLE :: exp_grid(:), intensities(:,:)
  
    
    real(8) :: min_energy, max_energy, E_step
    integer :: i, beam
    
    n_E_beams = NEE

    ! get E_step
    E_step = real(EE(1,2) - EE(1,1), 8)
    
    min_energy = MINVAL(EE(:,1))
    max_energy = MAXVAL(EE)
    print*, min_energy, max_energy, E_step

    n_E = NINT((max_energy - min_energy) / E_step) + 1
    allocate(exp_grid(n_E))

    do i = 1, n_E
      exp_grid(i) = min_energy + E_step*(i-1)
    end do
    
    allocate(intensities(n_E, n_beams))
    intensities = ieee_value(real(8), ieee_signaling_nan)
        ! row major order used in EE for some reason
        
    do beam = 1, n_beams
        do i = 1, n_E
            if (ABS(EE(beam,1) - exp_grid(i)) < 0.01) then
                E_start_beams(beam) = i
                exit
            end if
        end do
        
        intensities(E_start_beams(beam) : E_start_beams(beam) + n_E_beams(beam) -1, beam) = &
            AE(beam, 1 : NEE(beam))
    end do
    RETURN
end subroutine translate_exp


subroutine translate_theo(n_beams,  MNGP, MNBTD, ES, ATS, &
    n_E, theo_grid, E_start_beams, n_E_beams,  intensities)

    integer, INTENT(IN) :: n_beams
    integer, INTENT(IN) :: MNGP, MNBTD
    real(4), INTENT(IN) :: ES(MNGP), ATS(1, MNBTD, MNGP)

    integer, INTENT(OUT) :: n_E
    real(8), INTENT(OUT), ALLOCATABLE :: theo_grid(:)

    integer, INTENT(OUT) :: n_E_beams(n_beams), E_start_beams(n_beams)
    real(8), INTENT(OUT), ALLOCATABLE :: intensities(:,:)

    integer :: i, beam, en
    integer :: tmp_max_id_in_grid, tmp_max_id_out_grid


    ! Theory data is available for all energies - find which ones
    do i = 1, MNGP
        if ((ES(i) < 0.01)) then
            n_E = i - 1
            EXIT
        end if
    end do

    allocate(theo_grid(n_E))
    theo_grid = ES(1:n_E)
    
    ! is all data always available for 
    n_E_beams = n_E

    ALLOCATE(intensities(n_E, n_beams))
    intensities = ieee_value(real(8), ieee_signaling_nan)

    do beam = 1,MNBTD
        do en = 1,n_E
            if (ATS(1, beam, en) > 1e-8) then
                E_start_beams(beam) = en
                EXIT
            end if
        end do
        n_E_beams(beam) = n_E - E_start_beams(beam) + 1
        do en = E_start_beams(beam), n_E
            if (ATS(1, beam, en) < 1e-8) then
                ! max id reached
                n_E_beams = en - E_start_beams(beam) + 1
                EXIT
            end if
        end do

        intensities(E_start_beams(beam) : E_start_beams(beam) + n_E_beams(beam) - 1, beam) =  &
            ATS(1, beam, E_start_beams(beam) : E_start_beams(beam) + n_E_beams(beam) - 1)
    end do

    RETURN
end subroutine translate_theo


integer function test_compilation() result(ierr)
    !> This function tests if the module was correctly compiled.
    !! Some compilation flags may disable correct functioning of NaN 
    !! values which are required for the correct functioning of this module.
    real(8) :: test_value_nan, test_value_div

    test_value_nan = ieee_value(real(8), ieee_signaling_nan)
    test_value_div = 1.d0
    test_value_div = 1.d0/(1.d0 - test_value_div)

    if (ieee_is_finite(test_value_div) .or. ieee_is_normal(test_value_nan)) then
        !> Error in compilation
        ierr = 10
    else
        !> We are good to go
        ierr = 0
    end if

    return
end function test_compilation

end module r_factor_new

! Created by Alexander M. Imre on 04.12.21.
!
! Fast B-Spline Interpolation
! A part of ViPErLEED
!
! This module is designed to enable fast interpolation tailored to the requirements of TensorLEED calculations in ViPErLEED.
! At its heart, it performs a spline interpolation in the b-spline basis. The structure search of TensorLEED calculations requires frequent interpolation from
! a less dense origin grid to a more dense target grid. Unlike more general interpolation libraries, this module leverages that fact, by separating the interpolation
! into a pre-evaluation that only depends on the abcissaes of the grids, and an actual interpolation between the ordinate values.
! Large parts of the required calculations, e.g. the setup of the entire left hand side of the matrix equation, thus need only be performed once and can then be reused
! to interpolate an aribtrary number of datasets on the same grid.
! 
! This module is a part of ViPErLEED and is distributed under the same license.


! Error codes:
! ViPErLEED Interpolation Error codes start with 6
! 0 .. no error 
! 1-10 .. ?
! 11-19 .. error raised while performing checks on input data
! 11 ... origin grid not sorted
! 12 ... target grid not sorted


module interpolation
    use, intrinsic :: ieee_arithmetic
    implicit none
    
    contains

! *****************************************************************************************
! Routines to get array sizes

    pure subroutine get_array_sizes(n, deg, n_knots, nt, LHS_rows)
        ! Returns sizes of arrays used various parts of the interpolation. This is necessary since F2PY 
        ! wrapping requires explicit array shapes and does not allow for allocatable or assumed shape arrays.
        integer, INTENT(IN) :: n, deg

        integer, INTENT(OUT) :: n_knots
        integer, INTENT(OUT) :: nt
        integer, INTENT(OUT) :: LHS_rows

        integer :: kl, ku

        n_knots = n + 2*deg
        nt = n_knots - deg - 1
        kl = deg
        ku = deg
        LHS_rows = 2*kl + ku + 1
        RETURN
    end subroutine get_array_sizes

    pure subroutine de_Boor_size(n_new, deg, de_Boor_dim)
        ! Returns the size of the de Boor coefficient matrix
        integer,intent(in) :: n_new
        integer,intent(in) :: deg

        integer,INTENT(OUT) :: de_Boor_dim(2)

        de_Boor_dim(1) = 2*deg + 2
        de_Boor_dim(2) = n_new
        RETURN
    end subroutine de_Boor_size

! *****************************************************************************************
! Input grid pre-evaluation and spline coefficients

    subroutine single_calc_spline(&
        n, x, y, &
        deg, &
        n_knots, nt, LHS_rows, &
        knots, &
        coeffs, &
        ierr)

        ! IN
        integer, INTENT(IN) :: deg              !! order of spline
        integer, INTENT(IN) :: n        !! # points in
        real(8), INTENT(IN):: x(n)             !! origin grid values
        real(8), INTENT(IN):: y(n)
        integer, INTENT(IN) :: n_knots, nt, LHS_rows

        ! OUT
        real(8), INTENT(OUT)  :: knots(n_knots)                 !! knot points
        real(8), INTENT(OUT)  :: coeffs(nt)
        integer, INTENT(OUT)   :: ierr                    !! integer error code

        ! Internal
        integer  :: nleft, nright
        real(8) :: LHS(LHS_rows, nt)
        real(8) :: RHS (nt)
        integer  :: ipiv(nt)

        ierr = 0

        call pre_eval_input_grid(n, x, deg, &
            n_knots, nt, LHS_rows, &
            nleft, nright, &
            knots, LHS, RHS, ipiv, &
            ierr &
            )
            if (ierr .ne. 0) RETURN

        call calc_spline_with_pre_eval(&
            n, deg, &
            y, &
            nt, LHS_rows, &
            nleft, nright, &
            LHS, RHS, ipiv, &
            coeffs, &
            ierr)
    end subroutine single_calc_spline


    subroutine pre_eval_input_grid( &
        n, x, deg, &                                ! actual input arguments
        n_knots, nt, LHS_rows, & ! array sizes of output - formal input arguments
        nleft, nright, &
        knots, &
        LHS, &
        RHS, &
        ipiv, &
        ierr &
        )
        ! prepares LHS and RHS of the matrix equation for the spline coefficiencts
        ! Used in Structure search where many theoretical intensities need to be interpolated
        ! from the same starting grid.
        ! If you use this version, you should first call subroutine get_array_sizes to get the sizes
        ! of the arrays to expect returned.

        ! IN
        integer, INTENT(IN) :: n
        real(8), INTENT(IN):: x(n)             !! origin grid values
        integer, INTENT(IN) :: deg

        integer, INTENT(IN) :: n_knots
        integer, INTENT(IN) :: nt ! Size of LHS_cols, RHS_cols, coeffs and ipiv
        integer, INTENT(IN) :: LHS_rows
        

        ! OUT
        integer, INTENT(OUT)  :: nleft, nright !! number of knots for bc left and right
        real(8), INTENT(OUT) :: knots(n_knots) !! knot points
        real(8), INTENT(OUT) :: LHS(LHS_rows, nt)
        real(8), INTENT(OUT) :: RHS (nt)
        integer, INTENT(OUT) :: ipiv(nt)
        
        integer, INTENT(OUT)   :: ierr                    !! integer error code
        ! Internal
        integer                             :: kl, ku           !! matrix shape specifiers - in our case always equal deg
        integer                             :: LAPACK_info
        integer                             :: derivs_known_l, derivs_known_r
        integer, ALLOCATABLE                :: derivs_l_ord(:), derivs_r_ord(:)
        real(8), ALLOCATABLE                :: derivs_l_val(:), derivs_r_val(:)

   
        ierr = 0

        ! Compute knot vector and size
        call get_natural_knots(x, n, deg, n_knots, knots)

        ! Get the correct derivatives at the edge for the degree givennatural boundary conditions
        call prepare_derivs_nat_bc(deg, derivs_known_l, derivs_known_r, nleft, nright,&
        derivs_l_ord, derivs_r_ord, derivs_l_val, derivs_r_val)

        ! Using the derivatives and the x_values, we build up the LHS of the equation
        call build_LHS(n, x, n_knots, knots, deg, derivs_known_l, derivs_known_r, nleft, nright, &
            derivs_l_ord, derivs_r_ord, nt, LHS_rows, LHS)

        kl = deg
        ku = deg

        ! with this done, we can now prefactorize the LHS
        call pre_factorize_LHS(LHS, LHS_rows, nt, kl, ku, ipiv, LAPACK_info)

        if (LAPACK_info.ne.0) then
            ! Error in pre-factorization
            ierr = 621
            RETURN
        end if

        ! Now set up the RHS
        call prepare_RHS(nt, nleft, nright, derivs_l_val, derivs_r_val, RHS)

    end subroutine pre_eval_input_grid


    subroutine calc_spline_with_pre_eval(&
        n, deg, &
        y, &
        nt, LHS_rows, &
        nleft, nright, &
        LHS, RHS, ipiv, &
        coeffs, &
        ierr)
        ! Calculate spline coefficients given pre-calculated LHS and RHS from routine pre_eval_input_grid

        integer, INTENT(IN):: n
        real(8), INTENT(IN):: y(n)
        integer, INTENT(IN) :: deg

        integer, INTENT(IN)   :: nt, LHS_rows
        integer, INTENT(IN)   :: nleft, nright
        real(8), INTENT(IN)  :: LHS(LHS_rows, nt)
        real(8), INTENT(IN)  :: RHS(nt)
        integer, INTENT(IN)  :: ipiv(nt)

        real(8), INTENT(OUT) :: coeffs(nt)
        integer, INTENT(OUT) :: ierr

        ! Internal
        integer :: kl, ku, LAPACK_info
        ierr = 0
        call assign_y_to_RHS(y, RHS, nt, nleft, nright, coeffs)
        kl = deg
        ku = deg

        call solve_coeffcients(nt, kl, ku, LHS_rows, LHS, coeffs, ipiv, LAPACK_info)
        if ((LAPACK_info >0).or.(LAPACK_info<0)) then
            ierr = 631 ! LAPACK Error
        end if
        RETURN
    end subroutine calc_spline_with_pre_eval

! *****************************************************************************************
! Output grid pre-evaluation and interpolation

    subroutine single_interpolate_coeffs_to_grid(n_knots, knots, nt, coeffs, deg, &
        n_new, x_new, &
        nu, &
        y_new)

        ! IN
        integer, INTENT(IN) :: deg              !! order of spline
        integer, INTENT(IN) :: n_knots, nt, n_new         !! # points in, out
        real(8), INTENT(IN):: x_new(n_new)     !! result grid values
        real(8), INTENT(IN):: knots(n_knots)
        real(8), INTENT(IN):: coeffs(nt)
        integer, INTENT(IN) :: nu

        ! OUT
        real(8), INTENT(OUT):: y_new(n_new)
        ! Internal
        integer              :: intervals(n_new)        !! 1D integer array containg information, which spline interval the new grid points fall into.
        real(8), ALLOCATABLE  :: deBoor_matrix(:,:)      !! pre-evaluated deBoor matrix, required for evaluation of values on the new grid.
        integer :: de_Boor_dim(2)

        ! calculate interval vector for x_new
        call get_intervals(n_knots, knots, n_new, x_new, deg, intervals)

        call de_Boor_size(n_new, deg, de_Boor_dim)
        ALLOCATE(deBoor_matrix(de_Boor_dim(1), de_Boor_dim(2)))

        ! Build up the deBoor Matrix for x_new
        call calc_deBoor(n_knots, knots, n_new, x_new, deg, nu, intervals, &
            de_Boor_dim(1), de_Boor_dim(2), deBoor_matrix)
        call eval_bspline_fast(deg, nt, n_new, coeffs, intervals, deBoor_matrix, y_new)
    end subroutine single_interpolate_coeffs_to_grid


    subroutine get_intervals(n_knots, knots, n_new, x_new, deg, intervals)

        ! in
        integer, INTENT(IN) :: deg, n_new, n_knots
        real(8), INTENT(IN) :: knots(n_knots), x_new(n_new)

        integer, INTENT(out) :: intervals(n_new)

        integer :: extrapolate
        integer :: i, prev_l

        extrapolate = 0
        prev_l = deg
        do i=1,n_new
            intervals(i) = find_interval(knots, n_knots, deg, x_new(i), prev_l, extrapolate)
        end do
        RETURN
    end subroutine get_intervals


    subroutine calc_deBoor(n_knots, knots, n_new, x_new, deg, nu, intervals, deBoor_rows, deBoor_cols, deBoor_matrix)
        ! Calculates the deBoor_matrix
        ! IN
        integer, INTENT(in) :: n_knots, n_new, deg, nu
        real(8), INTENT(in) :: knots(n_knots), x_new(n_new)
        integer, INTENT(in) :: intervals(n_new)
        integer, INTENT(IN) :: deBoor_rows, deBoor_cols
        
        ! OUT
        real(8), intent(out) :: deBoor_matrix(deBoor_rows, deBoor_cols)

        ! internal
        integer :: i

        do i = 1, n_new
            call deBoor_D(knots, n_knots, x_new(i), deg, intervals(i), nu, deBoor_matrix(:,i))
        end do
        RETURN
    end subroutine calc_deBoor

! *****************************************************************************************
! Fast Evaluation of the B-Spline using prepared values

    pure subroutine eval_bspline_fast(&
        deg, nt, n_new, &
        coeffs, &
        intervals, &
        deBoor_matrix, &
        y_new &
        )
        ! TODO: see if this can be sped up. This is the rate limiting procedure

        ! in
        integer, INTENT(in) :: deg, n_new
        integer, INTENT(IN) :: nt
        integer, intent(in) :: intervals(n_new)
        real(8), INTENT(in) :: coeffs(nt)
        real(8), INTENT(IN):: deBoor_matrix(2*deg+2, n_new)

        ! out
        real(8), intent(out) :: y_new(n_new)

        ! internal
        integer :: i ! loop variable

        y_new = 0.0d0
        do concurrent (i = 1:n_new)
            ! whole array operations like the one below are faster than manual loops
            y_new(i) = sum(coeffs(intervals(i)-deg+1:intervals(i)+1)*deBoor_matrix(1:deg+1,i))
        end do
        RETURN
    end subroutine eval_bspline_fast

    pure subroutine eval_y_pendry_fast(&
        deg, nt, n_new, &
        coeffs, &
        intervals, &
        v0i, &
        deBoor_matrix_deriv_0, deBoor_matrix_deriv_1, &
        y_func &
        )
        ! evaluates the B-spline in the same way as eval_bspline_fast, but does it at once for
        ! the intensity and the derivative and returns the Pendry Y function directly.

        ! in
        integer, INTENT(in) :: deg, n_new, nt
        integer, intent(in) :: intervals(n_new)
        real(8), INTENT(in) :: coeffs(nt)
        real(8), INTENT(in) :: deBoor_matrix_deriv_0(2*deg+2, n_new)
        real(8), INTENT(in) :: deBoor_matrix_deriv_1(2*deg+2, n_new)
        real(8), INTENT(IN) :: v0i
    
        ! OUT
        real(8), INTENT(OUT) :: y_func(n_new)

        ! Internal
        integer i
        real(8) :: intensity(n_new), derivative(n_new)
        real(8) :: min_intensity
        
        y_func = 0.0d0
        do concurrent (i=1:n_new)
            ! intensity must be larger 0! (If not, add offset to raise above 0) ! TODO: add ierr for this!
            intensity(i) = sum(coeffs(intervals(i)-deg+1:intervals(i)+1)*deBoor_matrix_deriv_0(1:deg+1,i))
            intensity(i) = max(intensity(i), 0.0d0)
            !min_intensity = minval(intensity)
            !if (min_intensity < 0) then
            !    intensity = intensity + abs(min_intensity)
            !end if
            derivative(i) = sum(coeffs(intervals(i)-deg+1:intervals(i)+1)*deBoor_matrix_deriv_1(1:deg+1,i))
            y_func(i) = intensity(i)*derivative(i) /(intensity(i)*intensity(i) + v0i*v0i*derivative(i)*derivative(i))
        end do



    end subroutine eval_y_pendry_fast

! *****************************************************************************************
! Utility procedures

    subroutine perform_checks(n, x, n_new, x_new, ierr)
        implicit none
        integer, intent(in) :: n, n_new
        real(8), INTENT(IN) :: x(n), x_new(n_new)
        integer,intent(out) ::  ierr

        integer :: i ! loop var

        ierr = 0

        ! check if x values are sorted
        do concurrent (i = 2: n)
            if (x(i).le.x(i-1)) then
                ! origin grid not sorted
                ierr = 611
            end if
        end do

        do concurrent (i = 2: n_new)
            if (x_new(i).le.x_new(i-1)) then
                ! target grid not sorted
                ierr = 612
            end if
        end do

        RETURN
    end subroutine perform_checks


    pure subroutine equidist_to_array(n, x_start, x_step, x)
        integer, INTENT(IN)  :: n
        real(8), INTENT(IN) :: x_start, x_step

        real(8), INTENT(OUT) :: x(n)

        integer :: i

        do i = 1, n
            x(i) = x_start + x_step*(i-1)
        end do
        RETURN
    end subroutine equidist_to_array

! *****************************************************************************************
! Handeling of knots and boundary conditions
   
    subroutine get_natural_knots(x, n, deg, n_knots, knots)
        ! in
        integer,intent(in) :: n, deg
        real(8), INTENT(IN) :: x(n)
        integer, INTENT(IN) :: n_knots

        ! out
        real(8), intent(out) ::  knots(n_knots)


        knots(1       : deg     ) = x(1)
        knots(1+deg   : n+deg   ) = x(:)
        knots(n+deg+1 : n_knots ) = x(n)

        RETURN
    end subroutine get_natural_knots


    subroutine prepare_derivs_nat_bc(deg, derivs_known_l, derivs_known_r, nleft, nright,&
        derivs_l_ord, derivs_r_ord, derivs_l_val, derivs_r_val)
        integer, INTENT(IN) :: deg
        

        integer, INTENT(OUT) :: derivs_known_l, derivs_known_r, nleft, nright
        integer, ALLOCATABLE, INTENT(OUT) :: derivs_l_ord(:), derivs_r_ord(:)
        real(8), ALLOCATABLE, INTENT(OUT) :: derivs_l_val(:), derivs_r_val(:)

        if (deg == 3) then
            derivs_known_l = 1
            derivs_known_r = 1
            ALLOCATE(derivs_l_ord(derivs_known_l), derivs_r_ord(derivs_known_r))
            ALLOCATE(derivs_l_val(derivs_known_l), derivs_r_val(derivs_known_r))

            derivs_l_ord = (/2/)
            derivs_l_val = (/0d0/)

            derivs_r_ord = (/2/)
            derivs_r_val = (/0d0/)

            
        else if (deg == 5) then
            derivs_known_l = 2
            derivs_known_r = 2
            ALLOCATE(derivs_l_ord(derivs_known_l), derivs_r_ord(derivs_known_r))
            ALLOCATE(derivs_l_val(derivs_known_l), derivs_r_val(derivs_known_r))
            derivs_l_ord = (/3, 4/)
            derivs_l_val = (/0d0, 0d0/)

            derivs_r_ord = (/3, 4/)
            derivs_r_val = (/0d0, 0d0/)
        else
            print*, "Only order 3 and 5 supported so far"
            stop
        end if

        nleft = size(derivs_l_ord)
        nright = size(derivs_r_ord)
        RETURN

    end subroutine prepare_derivs_nat_bc

! *****************************************************************************************
! Internals for building LHS

    subroutine build_colloc_matrix(x, n, knots, n_knots, deg, AB, LHS_rows, LHS_cols, offset)
        ! -> bspl._colloc from scipy

        ! in
        integer, INTENT(IN) :: deg, n, n_knots, LHS_cols, LHS_rows
        real(8), intent(IN) :: x(n), knots(n_knots)
        ! out
        real(8), INTENT(INOUT) :: AB(LHS_rows,LHS_cols)
        ! internal
        integer :: left, j, a, kl, ku, clmn, nt, offset
        real(8) :: x_val
        real(8), ALLOCATABLE :: work(:)

        ku = deg
        kl = deg
        nt = n_knots - deg - 1

        allocate(work(2*deg+2))

        left = deg
        ! TODO fix indices
        do j=0, n-1
            x_val = x(j+1)
            left = find_interval(knots, n_knots, deg, x_val, left, 0) ! 0 means extrapolate = False

            call deBoor_D(knots, n_knots, x_val, deg, left, 0, work)

            do a = 0, deg
                clmn = left - deg + a
                AB(kl + ku + j + offset - clmn + 1, clmn +1 ) = work(a +1)
            end do
        end do

    end subroutine build_colloc_matrix


    subroutine handle_lhs_derivatives(knots, n_knots, deg, x_val, AB, LHS_rows, LHS_cols, kl, ku, deriv_ords, n_derivs, offset)
        implicit none

        ! in
        integer, INTENT(IN) :: deg, n_knots, LHS_cols, LHS_rows, offset, kl, ku, n_derivs, deriv_ords(n_derivs)
        real(8), intent(IN) :: knots(n_knots), x_val
        ! out
        real(8), INTENT(INOUT) :: AB(LHS_rows,LHS_cols)
        ! internal
        integer :: a, left, nu, row, clmn

        real(8), ALLOCATABLE :: work(:)
        
        ! derivatives @ x_val
        left = find_interval(knots, n_knots, deg, x_val, deg, 0)

        ! allocate work array
        ALLOCATE(work(2*deg+2))
        do concurrent (row=0: n_derivs-1)
            nu = deriv_ords(row+1)
            call deBoor_D(knots, n_knots, x_val, deg, left, nu, work)

            do a = 0, deg
                clmn = left - deg + a
                AB(kl + ku + offset + row - clmn + 1, clmn +1 ) = work(a +1)
            end do
        end do
    end subroutine handle_lhs_derivatives

! *****************************************************************************************
! de Boor B-spline evaluation

    pure subroutine deBoor_D(knots, n_knots, x, deg, ell, m, result)
        ! analogous to _deBoor_D from fitpack.h in scipy
        ! Comment from SciPy:

    
        ! On completion the result array stores
        ! the k+1 non-zero values of beta^(m)_i,k(x):  for i=ell, ell-1, ell-2, ell-k.
        ! Where t[ell] <= x < t[ell+1].
        !
        ! Implements a recursive algorithm similar to the original algorithm of
        ! deBoor.

        use, intrinsic :: iso_fortran_env
        implicit none
        integer, parameter :: dp = REAL64

        !in
        integer, INTENT(IN) :: n_knots, ell
        integer, INTENT(IN) :: deg !degree
        integer, INTENT(IN) :: m ! which derivatives to evaluate

        real(8), INTENT(IN) :: x, knots(n_knots)

        real(8), INTENT(INOUT) :: result(deg+1)

        !internal
        real(8) :: xb, xa, w
        integer :: ind, j, n, i
        real(8) :: hh(deg)

        ! Comment from SciPy:
        ! Perform k-m "standard" deBoor iterations
        ! so that h contains the k+1 non-zero values of beta_{ell,k-m}(x)
        ! needed to calculate the remaining derivatives.
        
        result(1) = 1.0d0
        j =1
        do while (j<= deg-m)
            do i=1,j
                hh(i) = result(i)
            end do
            result(1) = 0.0d0
            n = 1
            do while (n<=j)
                ind = ell +n
                xb = knots(ind +1)
                xa = knots(ind -j +1)
                if (xb == xa) then
                    result(n+1) = 0.0d0
                    continue
                end if
                w = hh(n-1 +1)/(xb-xa)
                result(n-1+1) = result(n-1+1) + w*(xb-x) ! result(n) += w*(xb-x)
                result(n+1) = w*(x-xa)
            n = n+1
            end do
        j = j+1
        end do

        ! Comment form SciPy:
        ! Now do m "derivative" recursions
        ! to convert the values of beta into the mth derivative
        j = deg-m+1
        do while(j<=deg)
            do i=1,j
                hh(i) = result(i)
            end do
            result(1) = 0.0d0
            n = 1
            do while(n<=j)
                ind = ell + n
                xb= knots(ind +1)
                xa = knots(ind -j +1)
                if (xb == xa) then
                    result(m +1) = 0.0d0
                    continue
                end if
                w = j*hh(n-1+1)/(xb-xa)
                result(n-1+1) = result(n-1+1) -w
                result(n+1) = w
            n= n+1
            end do
        j = j+1
        end do
    end subroutine deBoor_D

! *****************************************************************************************
! Assigning grid points to spline intervals

    pure function find_interval(knots, n_knots, deg, x_val, prev_l, extrapolate) result(interval)

        integer, INTENT(IN) :: n_knots, deg, extrapolate, prev_l
        real(8), INTENT(IN) :: knots(n_knots), x_val

        integer interval

        ! internal
        integer :: l, n
        real(8) :: tb, te

        ! TODO Fortran indices fix!
        n = n_knots - deg - 1
        tb = knots(deg+1)   !Fortran index
        te = knots(n+1)     !Fortran index

        ! reference code checks for NaN in x_val -> skipped here

        if (((x_val < tb).or.(x_val > te)).and.(extrapolate==0)) then
            ! TODO implement ierr here!
            interval = -1
            RETURN
        end if 

        if ((deg < prev_l).and.(prev_l<n)) then
            l = prev_l
        else
            l = deg
        end if

        do while ((x_val < knots(l+1)).and.(l.ne.deg)) !Fortran index
            l = l-1
        end do

        l = l+1

        do while ((x_val>=knots(l+1)).and.(l.ne.n)) !Fortran index
            l = l + 1
        end do

        interval = l-1

        return
    end function find_interval


! *****************************************************************************************
! Preparing the left hand side (LHS) of the equation. The LHs holds the original grid (knots) and info on the boundary conditions.
! As long as the origin grid and boundary conditions stay the same, the LHS is unchanged and can be pre-evaluated.    

    subroutine build_LHS(n, x, n_knots, knots, deg, derivs_known_l, derivs_known_r, nleft, nright, &
                            derivs_l_ord, derivs_r_ord, nt, LHS_rows, LHS)
        implicit none
        ! in
        integer,intent(in) :: n, n_knots, deg
        real(8), intent(in) :: x(n), knots(n_knots)
        integer, INTENT(IN) :: derivs_known_l, derivs_known_r, nleft, nright
        integer, INTENT(IN) :: derivs_l_ord(derivs_known_l)
        integer, INTENT(IN) :: derivs_r_ord(derivs_known_r)
        integer, INTENT(IN) :: nt, LHS_rows

        !out
        real(8), INTENT(OUT) :: LHS(LHS_rows, nt)

        ! Internal
        integer :: kl, ku

        ! Set up left hand side
        LHS = 0.0d0

        ku = deg
        kl = deg

        call build_colloc_matrix(x, n, knots, n_knots, deg, LHS, LHS_rows, nt, nleft)
        if (nleft>0) then
            call handle_lhs_derivatives(knots, n_knots, deg, x(1), LHS, LHS_rows, nt, kl, ku, &
            derivs_l_ord, derivs_known_l, 0)
        end if
        if (nright>0) then
            call handle_lhs_derivatives(knots, n_knots, deg, x(n), LHS, LHS_rows, nt, kl, ku, &
            derivs_r_ord, derivs_known_r, nt-nright)
        end if
    end subroutine build_LHS


    subroutine pre_factorize_LHS(LHS, LHS_rows, nt, kl, ku, ipiv, info)

        ! in
        integer, INTENT(IN) :: LHS_rows
        integer, INTENT(IN) :: nt, kl, ku

        ! inplace
        real(8), INTENT(INOUT) :: LHS(LHS_rows, nt)

        ! out
        integer, INTENT(OUT) :: ipiv(nt) ! TODO is this even needed afterwards?
        integer, INTENT(OUT) :: info

        ! Compute the LU factorization of the band matrix A.

        CALL dgbtrf(nt, nt, kl, ku, LHS, 2*kl+ku+1, ipiv, info)

    end subroutine pre_factorize_LHS

! *****************************************************************************************
! Deal with right hand side (RHS) of the equation
! The RHS holds the values at the knot points, i.e. in our case the y values and derivatives at the edge

    subroutine prepare_RHS(nt, nleft, nright, derivs_l_val, derivs_r_val, rhs)
        ! Allocates the right size for the RHS and fills in derivatives at the edge.
        ! The other values are set to NaN and need to be filled in by the y values for actual interpolation
        ! in
        integer, INTENT(IN) :: nt, nleft, nright
        real(8), INTENT(IN) :: derivs_l_val(nleft), derivs_r_val(nright)

        ! out
        real(8), INTENT(OUT) :: rhs(nt)


        if (nleft>0) then
            rhs(1:nleft) = derivs_l_val
        end if
        if (nright>0) then
            rhs(nt - nright +1: nt) = derivs_r_val
        end if
        ! Assign NaNs in all places where y needs to go, so that if the array is used without assignment, an error will be thrown.
        rhs(nleft + 1 : nt - nright) = ieee_value(real(8), ieee_signaling_nan)
        RETURN
    end subroutine prepare_RHS


    subroutine assign_y_to_RHS(y, rhs_prep, nt, nleft, nright, rhs)
        ! in
        integer, INTENT(IN) :: nt, nleft, nright
        real(8), INTENT(IN) :: y(nt - nleft - nright)
        real(8), INTENT(IN) :: rhs_prep(nt)
        ! out
        real(8), INTENT(OUT) :: rhs(nt)

        ! Since rhs will be overwritten by LAPACK, it needs to be copied at some point prior
        rhs = rhs_prep
        rhs(nleft+1:nt-nright) = y ! assign y values
        RETURN
    end subroutine assign_y_to_RHS

! *****************************************************************************************
! Solve for the B-Spline coefficients given prepared LHS and RHS

    subroutine solve_coeffcients(nt, kl, ku, LHS_rows, LHS, RHS, ipiv, info)
        ! Now we are ready to solve the matrix!
        ! Using LAPACKs' GBSV routine
        ! On exit, rhs is overwritten by the solution coeffs

        ! in
        integer, INTENT(IN) :: nt, kl, ku, LHS_rows
        real(8), intent(in) :: LHS(LHS_rows, nt)
        real(8), INTENT(INOUT) :: RHS(nt)

        ! inout
        integer, intent(IN) :: ipiv(nt) ! must be inout, but not actually used
        integer, INTENT(INOUT) :: info
    
        ! result (= coeffs) get written into RHS -> thus copy first
        ! LHS will also be overwritten! TODO
        call dgbtrs('No transpose', nt, kl, ku, 1, LHS, 2*kl+ku+1, ipiv, RHS, nt, info)

        return
    end subroutine solve_coeffcients


end module interpolation

! A program to test out my new interpolation algorithm and compare it to other options

program intpol_test

    USE tenserleed_intpol
    !use bspline_module
    !use bspline_kinds_module, only: wp, ip
    use, intrinsic :: iso_fortran_env
    use lapack
    use utils
    use splines, only : spline3
    use interpolation
    implicit none
    integer, parameter :: fdp = REAL64
    ! Test data
    integer :: n_points, n_points_supersampled
    real(fdp), external :: test_data
    real(fdp), ALLOCATABLE :: x_data(:), y_data(:), new_y(:), new_y_comp(:), x_ss(:), y_ss(:), my_knots(:), y_new_deriv(:)
    !real(wp), ALLOCATABLE :: x(:), y(:), nx(:), ny(:)
    integer :: deg, i, j, new_n, ierr, n_my_knots
    real(fdp), ALLOCATABLE :: LHS(:,:), RHS(:), RHS_prep(:)
    integer :: nt, kl, ku, lhs_rows, lhs_cols, RHS_cols, nleft, nright
    integer, ALLOCATABLE :: ipiv(:)

    integer, ALLOCATABLE :: intervals(:)
    real(fdp), ALLOCATABLE :: deBoor_matrix(:,:), coeffs(:), deriv_deBoor_matrix(:,:)
    !integer :: info_values(info_size)


    ! for timing the calls
    real(fdp) :: start, finish, exec_time
    integer :: repeats

    ! for TensErLEED
    integer :: NGP, NB, ipr, ib, NE
    real(fdp), ALLOCATABLE :: A(:), E(:), X_TL(:), WORYT(:)
    real(fdp) :: EINCR

    integer :: n_knots, de_Boor_dim(2) !, nt, LHS_rows
    real(fdp), ALLOCATABLE :: knots(:)

    ! Setup Data to interpolate
    print*, "Version with custom datatypes"
    repeats = 1000
    n_points = 600
    n_points_supersampled = n_points*5

    print*, "Interpolation Benchmark"
    print*, "N repeats :             ", repeats
    print*, "N points :              ", n_points
    print*, "N points supersampled : ", n_points_supersampled

    new_n = n_points_supersampled
    Allocate(x_data(n_points))
    ALLOCATE(y_data(n_points))
    ALLOCATE(x_ss(n_points_supersampled))
    ALLOCATE(new_y(n_points_supersampled), y_ss(n_points_supersampled), new_y_comp(n_points_supersampled))

    do i =1, n_points
        x_data(i) = 6d0/n_points*(i-1)! interval from -3 to 3
        y_data(i) = test_data(x_data(i))
    end do
    do i = 1, n_points_supersampled
        x_ss(i) = (6d0-0.1d0)/n_points_supersampled*(i-1) ! interval from -3 to 3
        y_ss(i) = test_data(x_ss(i)) 
    end do


    OPEN(10, file = "x_data.csv", STATUS='REPLACE')
    OPEN(20, file = "y_data.csv",STATUS='REPLACE')
    OPEN(30, file = "y_ss.csv",STATUS='REPLACE') !supersampled (real) y values
    OPEN(40, file = "x_ss.csv",STATUS='REPLACE') !supersampled x_values
    do i= 1,n_points
        write(10, *) x_data(i)
        write(20, *) y_data(i)
    end do
    do i = 1, n_points_supersampled
        write(30, *) y_ss(i)
        write(40, *) x_ss(i)
    end do
    CLOSE(10)
    CLOSE(20)
    Close(30)
    CLOSE(40)

    ! Test out interpolation as used in TensErLEED Refcalc
    ngp = n_points_supersampled+200 ! array size; bigger than n_points and n_points_supersampled
    NE = n_points
    EINCR = x_ss(2)-x_ss(1) ! Delta E value
    ib = 1 !beam number, dummy
    ipr = 0 ! write flag, dummy (!= 2)
    ALLOCATE(A(NGP), E(NGP), WORYT(NGP), X_TL(NGP))
    A = 0.0
    E = 0.0
    A(1:NE) = y_data
    E(1:NE) = x_data
    X_TL = 0.0
    WORYT = 0.0

    call cpu_time(start)
    do i=1, repeats
        CALL INTPOL(A,NE,E,NGP,EINCR,IPR,X_TL,WORYT,IB)
    end do
    call cpu_time(finish)
    exec_time = (finish - start)/repeats
    print*, "TensErLEED Interpolation:         ", exec_time, "s."!," For results see file: ", "y_out_TLEED.csv" 
    OPEN(99, file = "y_out_TLEED.csv", STATUS='REPLACE')
    do i=2, n_points_supersampled
        WRITE(99,*) A(i-1)
    end do
    CLOSE(99)

    ! Test out interpolation via my own module
    
    deg = 5
    new_y_comp = 1.0d0
    call cpu_time(start)



    call get_array_sizes(n_points, deg, n_knots, nt, LHS_rows)
    call de_Boor_size(n_points_supersampled, deg, de_Boor_dim)

    ALLOCATE(knots(n_knots), coeffs(nt), LHS(lhs_rows, nt))
    ALLOCATE(deBoor_matrix(de_Boor_dim(1), de_Boor_dim(2)))
    DEALLOCATE(LHS)
    ALLOCATE(LHS(lhs_rows, nt), RHS(nt), ipiv(nt), intervals(n_points_supersampled))

 

    call pre_eval_input_grid( &
        n_points, x_data, deg, &                                ! actual input arguments
        n_knots, nt, LHS_rows, & ! array sizes of output - formal input arguments
        nleft, nright, &
        knots, &
        LHS, &
        RHS, &
        ipiv, &
        ierr &
        )

    call get_intervals(n_knots, knots, n_points_supersampled, x_ss, deg, intervals)

    call calc_deBoor(n_knots, knots, n_points_supersampled, x_ss, deg, 0, intervals, deBoor_matrix)

    do i=1, repeats
        call calc_spline_with_pre_eval(&
        n_points, deg, &
        y_data, &
        n_knots, nt, LHS_rows, &
        knots, &
        nleft, nright, &
        LHS, RHS, ipiv, &
        coeffs, &
        ierr)

        call eval_bspline_fast(&
            deg, nt, n_points_supersampled, &
            coeffs, &
            intervals, &
            deBoor_matrix, &
            new_y_comp &
            )
        
    end do

    call cpu_time(finish)
    exec_time = (finish - start)/repeats
    if (ierr.ne.0) then
        print*, "Error thrown", ierr
    end if
    print*, "My Interpolation 5th Order (new): ", exec_time, "s."!, " For results see file: ", "y_out_my_5.csv" 
    OPEN(99, file = "y_out_my_5.csv", STATUS='REPLACE')
    OPEN(98, file = "y_out_my_5_deriv.csv", STATUS='REPLACE')
    do i=1, n_points_supersampled
        WRITE(99,*) new_y_comp(i)
        !WRITE(98,*) y_new_deriv(i)
    end do
    CLOSE(99)
    CLOSE(98)

    
    !DEALLOCATE(my_knots)
    !DEALLOCATE(intervals)
    !DEALLOCATE(LHS, RHS)
    !DEALLOCATE(coeffs)
    !DEALLOCATE(y_new_deriv)


    ! ! Test out interpolation with Fortran-Bsplines library
    ! deg = 3
    ! new_y = 1.0d0
    ! x = x_data
    ! y = y_data
    ! nx = x_ss
    
    ! k = deg+1
    ! np = n_points
    ! one = 1
    ! zero = 0
    ! extrap = .False.  
    ! call cpu_time(start)
    ! ALLOCATE(knots(np+k))
    ! ALLOCATE(bcoef(np))
    ! ALLOCATE(ny(n_points_supersampled))
    ! ALLOCATE(work(3*k))
    ! !CALL db1ink(x, k, np, y, 0, knots, bcoef, iflag
    ! do i = 1, repeats
    !     call db1ink(x,np,y,k,zero,knots,bcoef,iflag)
    !     do j=1,n_points_supersampled
    !         call db1val(nx(j), zero, knots, np, k, bcoef, ny(j), iflag, one, work, extrap)
    !     end do
    ! end do
    ! call cpu_time(finish)
    ! exec_time = (finish - start)/repeats
    ! print*, "F-Bspline Package 3rd Order:      ", exec_time, "s."!," For results see file: ", "y_out_bspline_pckg3.csv" 
    ! OPEN(99, file = "y_out_bsplines_pckg3.csv", STATUS='REPLACE')
    ! do i=1, n_points_supersampled
    !     WRITE(99,*) ny(i)
    ! end do
    ! CLOSE(99)
    ! DEALLOCATE(knots)
    ! DEALLOCATE(bcoef)
    ! DEALLOCATE(ny)
    ! DEALLOCATE(work)

    ! Test out interpolation with Fortran-Bsplines library
    ! deg = 5
    ! new_y = 1.0d0
    ! x = x_data
    ! y = y_data
    ! nx = x_ss
    
    ! k = deg+1
    ! np = n_points
    ! one = 1
    ! zero = 0
    ! extrap = .False.  
    ! call cpu_time(start)
    ! ALLOCATE(knots(np+k))
    ! ALLOCATE(bcoef(np))
    ! ALLOCATE(ny(n_points_supersampled))
    ! ALLOCATE(work(3*k))
    ! !CALL db1ink(x, k, np, y, 0, knots, bcoef, iflag
    ! do i = 1, repeats
    !     call db1ink(x,np,y,k,zero,knots,bcoef,iflag)
    !     do j=1,n_points_supersampled
    !         call db1val(nx(j), zero, knots, np, k, bcoef, ny(j), iflag, one, work, extrap)
    !     end do
    ! end do
    ! call cpu_time(finish)
    ! exec_time = (finish - start)/repeats
    ! print*, "F-Bspline Package 5th Order:      ", exec_time, "s." !," For results see file: ", "y_out_bspline_pckg3.csv" 
    ! OPEN(99, file = "y_out_bsplines_pckg5.csv", STATUS='REPLACE')
    ! do i=1, n_points_supersampled
    !     WRITE(99,*) ny(i)
    
    ! end do
    ! CLOSE(99)

!   !  Test out interpolation with Fortran-Utils Module
!    deg = 3
!    new_y = 1.0d0
!    call cpu_time(start)
!    do i=1, repeats
!        new_y = spline3(x_data,y_data,x_ss)
!    end do
!    call cpu_time(finish)
!    exec_time = (finish - start)/repeats
!    print*, "Cubic Spline from fortran-utils:  ", exec_time, "s."!," For results see file: ", "y_out_futils.csv" 
!    OPEN(99, file = "y_out_futils.csv", STATUS='REPLACE')
!    do i=1, n_points_supersampled
!        WRITE(99,*) new_y(i)
!    end do
!    CLOSE(99)

end program intpol_test


function test_data(x_in) result(y_out)
    use iso_fortran_env
    integer, PARAMETER :: dp = real64
    real(dp), INTENT(IN) :: x_in
    real(dp) :: y_out
    real(dp) :: a
    a = 5

    y_out = 2d0 + cos(a*(x_in-3.0d0))*exp(-(x_in-3.0d0)**2)
    !y_out = 2d0 + cos(x_in*8) + 3*exp(-abs(x_in-2.0d0)**2) + 0.2d0*sin(1.5*x_in) +min(tan(x_in)**2,2.0d0)
    return
end function test_data
